/* TI Emulator for Amiga! Modified to PC! */
/* Ami99 by Mike Brent */

// **FINAL** (public version)
// Intended for Microsoft Visual C++ 5.0 and Allegro WIP 4
// good luck


#include <stdio.h>
#include <string.h>
#include <dirent.h>

#include <allegro.h>

#ifdef __linux__
#include <signal.h>
#include <sys/time.h>
#include <math.h>
/*  #include <vga.h> */
/*  #include <vgagl.h> */
/*  #include <vgakeyboard.h> */
/*  #include "tiemul-linux.h" */
#else
#pragma warning (disable: 4113 4761)
#define WIN32_LEAN_AND_MEAN
#define BITMAP WINDOWS_BITMAP
#include <windows.h>
#undef BITMAP
#undef RGB
#include <winalleg.h>
#pragma hdrstop
#endif

#include "tiemul.h"

char qw[80];  /* temporary string */

char quitflag;  /* just what it says */

int redraw_needed; /* set after write access to VDP RAM or register */
int setpalette_needed; /* set after write access to color definitions */
int rebuild_patterns_needed; /* set after write access to PDT */

int interrupt_needed;	/* set if we miss a VDP interrupt due to masking */

Byte CPU[65536], CPU2[8192], GROM[65536];
/*  Byte VDP[16384], VDPREG[9]; */
Byte VDP[0x40000], VDPREG[64], VDPS[16];/* 40000/64/16 instead of
										   30000/47/9 Bytes
										   for easier access */
/*   CPU m6emory- XB bank 2-  GROM memory- VDP memory- VDP registers */

Byte ROMMAP[65536], CRU[65536];
/* map of which CPU bytes are writeable, the CRU area */

Word PC, WP, X_flag;
/* program counter and workspace pointer , and X_flag for 'X' */

int bank=0,xb=0;
/* which bank is active, and is XB even loaded? */

Word ST;
/* status register. bit definitions follow */

char *diskpath[10];				/* path to disk directories or images */
char disktype[10];				/* i=image, v=files with v9t9 header,
								   t=files with TIFILES header,
								   r=raw program files without header */
int v9938 = 0;					/* emulate V9938 video display processor */
int speedup_float = 0;			/* speedup floating point operations */
int speedup_fr213 = 0;			/* speedup fractal calculation */

int mode, oldmode=-1;			/*  current graphics mode and old value */

int wti=256, hti=192, wscr, hscr, oldwscr=-1;

int num_sprites,y_speed,x_speed,t1,t1a,t1b,t2,t2a,t2b,sprite_y,sprite_x,offset;
int ty,tx;

int mx=0, my=0, oldmx, oldmy;		/* mouse position, old values */

int snd_address;
Byte *sndlist, data;
/* used in console interrupt simulator */

int need_byte, last_byte;
/* used in sound routine */

// The keyboard routine is still broken, especially for joysticks
// Keys all seem right, though?
int KEYS[8][8]= { 

/* Joy 2 */		KEY_ESC, KEY_ESC, KEY_ESC, KEY_ESC, KEY_ESC, KEY_ESC, KEY_ESC, KEY_ESC,

/* 0 */			KEY_M, KEY_J, KEY_U, KEY_7, KEY_4, KEY_F, KEY_R, KEY_V,
/* 1 */			KEY_SLASH, KEY_COLON, KEY_P, KEY_0, KEY_1, KEY_A, KEY_Q, KEY_Z,
/* 2 */			KEY_STOP, KEY_L, KEY_O, KEY_9, KEY_2, KEY_S, KEY_W, KEY_X,

/* Joy 1 */		KEY_TAB, KEY_RIGHT, KEY_LEFT, KEY_UP, KEY_DOWN, KEY_ESC, KEY_ESC, KEY_ESC,
	
/* 3 */			KEY_COMMA, KEY_K, KEY_I, KEY_8, KEY_3, KEY_D, KEY_E, KEY_C,
/* 4 */			KEY_N, KEY_H, KEY_Y, KEY_6, KEY_5, KEY_G, KEY_T, KEY_B,
/* 5 */			KEY_EQUALS, KEY_SPACE, KEY_ENTER, KEY_ESC, KEY_ALT, KEY_LSHIFT, KEY_LCONTROL, KEY_ESC 
};


/////////////////////////////////////////////////////////////////////
// Status register defines
/////////////////////////////////////////////////////////////////////
#define ST_LGT (ST&0x8000)							// Logical Greater Than
#define ST_AGT (ST&0x4000)							// Arithmetic Greater Than
#define ST_EQ  (ST&0x2000)							// Equal
#define ST_C   (ST&0x1000)							// Carry
#define ST_OV  (ST&0x0800)							// Overflow
#define ST_OP  (ST&0x0400)							// Odd Parity
#define ST_X   (ST&0x0200)							// Set during an XOP instruction
#define ST_INTMASK (ST&0x000f)						// Interrupt mask (the TI uses only values 0 and 2)

#define set_LGT (ST|=0x8000)						// Set the flags
#define set_AGT (ST|=0x4000)
#define set_EQ  (ST|=0x2000)
#define set_C   (ST|=0x1000)
#define set_OV  (ST|=0x0800)
#define set_OP  (ST|=0x0400)
#define set_X   (ST|=0x0200)

#define reset_LGT (ST&=0x7fff)					// Clear the flags
#define reset_AGT (ST&=0xbfff)
#define reset_EQ  (ST&=0xdfff)
#define reset_C   (ST&=0xefff)
#define reset_OV  (ST&=0xf7ff)
#define reset_OP  (ST&=0xfbff)
#define reset_X   (ST&=0xfdff)

#define reset_EQ_LGT (ST&=0x5fff)


Word VDPADD, GRMADD;   /* VDP and GROM address registers */

//Word VDPST;           /* VDP status register */
#define VDPST VDPS[0]

Byte grmaccess,grmdata; /* used with GROM emulation (prefetch) */

Byte vdpaccess;         /* used with VDP address access */
int firstcolorbyte = -1;		/* first of two bytes defining a color (v9938) */

unsigned int index1;    /* general counter variable */

Word in,D,S,Td,Ts,B;   /* opcode in, and the breakdown of the opcode */

int debug, d2, olddebug=-1;		/* debugging flags */
int debugadr=0, debugadrv=0;
Word debugadrm=0, debugadrg=0, breakpoint=0;

int drawspeed=0;            /* flag for display drawing */
int kscan=0;				/* use KSCAN speed up */
int max_ipf=9999999;		/* 10 million instructions per frame.. way faster than my PC ;) */
int oldmax=9999999;									// copy of same
int instruction_count;		/* used in speed control */

int cpucount, cpuframes;  /* used for instructions/second */
int last_count=0;				/* used to separate video redraws and VDP ints */
int timercount;           /* used to guestimate run-time */

void (*opcode[65536])(void); /* array for CPU table */

SAMPLE *spl[9];
int voice[4];

#include "tivdp.c"

#ifdef __linux__

void timer_handler(int s) {
  retrace_count++;
  interrupt_needed=1;
  VDPS[2] ^= 0x62;				/* toggle HR, VW, and EO */
  VDPS[8]++;					/* FIXME: test */
  //  signal (s, timer_handler);	/* reinstall (only SYSV) */
}

int main(int argc, char *argv[]) {
  struct itimerval timerval;

  if (signal(SIGVTALRM, timer_handler)==SIG_ERR)
	fail("Can't install signal handler");

 /* FIXME: using virtual timer, real timer used by allegro */
  timerval.it_interval.tv_usec = (long int) 20000;/* 20ms virtual time */
  timerval.it_interval.tv_sec = 0;
  timerval.it_value.tv_usec = (long int) 50000; /* 50ms */
  timerval.it_value.tv_sec = 0;
  if (setitimer (ITIMER_VIRTUAL, &timerval, NULL) < 0)
	fail("Can't install timer");

#else
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpCmdLine, int nCmdShow) {
#endif
		allegro_init();

		set_window_title("Ami99");
	    
		install_keyboard();
		install_timer();

		grmaccess=0;
		vdpaccess=0; /* no VDP address writes yet */
		quitflag=1;  /* no quit */
		interrupt_needed=0;	/* ok so far */

		VDPBUFFER=SPRITEBUFFER=SCREENBUFFER=0;

		/* clear memory banks */

		memset(CPU, 0, 65536);
		memset(CPU2, 0, 16384);
		memset(GROM, 0, 65536);
		memset(VDP, 0, 0x30000);
		memset(VDPREG, 0, 47);
		memset(VDPS, 0, 9);
		VDPS[7]=1;				/* FIXME: for a test to make it
								   different from #0 */
		memset(CRU, 1, 4096);
/*  		for (index1=0; index1<65536; index1++) */
/*  		  CPU[index1]=0; */
/*  		for (index1=0; index1<8192; index1++) */
/*  		  CPU2[index1]=0; */
/*  		for (index1=0; index1<65536; index1++) */
/*  		  GROM[index1]=0; */
/*  		for (index1=0; index1<16384; index1++) */
/*  		  VDP[index1]=0; */
/*  		for (index1=0; index1<4096; index1++) */
/*  		  CRU[index1]=1; */

		debug=0;

		readroms();

		buildcpu();

		startsound();
		
		startvdp();

		if (v9938)
		  install_mouse();

		/* that SHOULD set up the PC. now go do the TI stuff! */

		cpucount=0;
		cpuframes=0;
		timercount=0;

		emulti();
		closeall();

	return 0;
}

void startsound()
{ /* start up the sound files */
	int i;
	char buf[80];

	int detect_digi_driver(int driver_id);

	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0)
	{	if (install_sound(DIGI_NONE, MIDI_NONE, NULL) != 0)
			fail("Can't install sound");
	}
	
	set_volume(255, -1);	/* max digi volume, ignore midi */

	spl[0]=load_sample("tone.wav");			/* this is a short wav at 22khz, playing a 550hz tone */
	if (spl[0] == 0)
	  fail("Can't load sound");
	
	for (i=1; i<9; i++)
	{
		sprintf(buf,"noise%d.wav",i);
		spl[i]=load_sample(buf);
		if (spl[i] == 0)
		  fail("Can't load noise");
	}

	for (i=0; i<3; i++)
	{	voice[i]=allocate_voice(spl[0]);			/* start the sample */
		voice_set_playmode(voice[i],PLAYMODE_LOOP); /* loop it */
		voice_start(voice[i]);					/* start playing */
		voice_set_frequency(voice[i], 5000*i);  /* make the annoying WHONK before init ;) */ 
	}
	voice[3]=allocate_voice(spl[1]);
	voice_set_playmode(voice[3], PLAYMODE_LOOP);
	voice_start(voice[3]);						/* join in */

	need_byte=0;
	last_byte=0;

}

void startvdp()
{ /* set up VDP program */
VDPmain();
retrace_count=0;
}

void warn(x) char x[];
{ /* ***eventually*** pop up a warning window with the PC */
fail(x);
}

void fail(x) char x[];
{ /* report a fatal error */
char buffer[1024];
char buf2[256];

while (keypressed())
{ readkey();
}

if (VDPBUFFER) destroy_bitmap(VDPBUFFER);
if (SPRITEBUFFER) destroy_bitmap(SPRITEBUFFER);
if (SCREENBUFFER) destroy_bitmap(SCREENBUFFER);

allegro_exit();

sprintf(buffer,"\n%s\n",x);
sprintf(buf2,"PC-%.4X  WP-%.4X  ST-%.4X  OP-%.4X\nGROM-%.4X VDP-%.4X\n",PC,WP,ST,in,GRMADD,VDPADD);
strcat(buffer,buf2);
sprintf(buf2,"Run Duration  : %d seconds\n",timercount/70);
strcat(buffer,buf2);
sprintf(buf2,"Operation time: %d instructions processed.\n",cpucount);
strcat(buffer,buf2);
sprintf(buf2,"Display frames: %d video frames displayed.\n",cpuframes);
strcat(buffer,buf2);
if (timercount<70) timercount=70;	/* avoid divde by zero */
sprintf(buf2,"Average speed : %d instructions per second.\n",cpucount/(timercount/70));
strcat(buffer,buf2);
sprintf(buf2,"Frameskip     : %d\n",drawspeed);
strcat(buffer,buf2);

MessageBox(NULL, buffer, "Ami99 Exit", MB_OK);   

closeall();

exit(1);
}

void closeall()
{ 
}

Word romword(x) Word x;
{ /* returns a word from ROM */
x&=0xfffe;
return((Word)((rcpubyte(x)<<8)+rcpubyte(x+1)));
}

void wrword(x,y) Word x,y;
{ /* write a word to RAM */
x&=0xfffe;
wcpubyte(x,(Byte)(y>>8));
wcpubyte(x+1,(Byte)(y&0xff));
}

void emulti()
{ /* emulate a TI99/4a */
/* First, read in the ROM stuff, using the data file TIDATA */
WP=romword(0);
PC=romword(2);
X_flag=0;  /* not doing an 'X' right now */
quitflag=1;
while (quitflag)
{ do1();
}
fail("STOPPED!");
}

void readroms()
{ /* this routine reads TIDATA, and uses it to load the read-only stuff */
FILE *fp, *fp2;
int flag;
char type;
Byte c;
unsigned short address, length;

 for (index1=0; index1<10; index1++)
   diskpath[index1] = NULL;


/* set all CPU memory as RAM */
for (index1=0; index1<65536; index1++)
  ROMMAP[index1]=0;

fp=fopen("TIDATA","r");
if (fp==NULL) fail("Can't open TIDATA file!");
flag=1; 

while (flag)
{ flag=(int)fgets(qw,80,fp);
  if (qw[0]=='#')
  {
	  if (strncasecmp(qw,"#FRAMESKIP",10) == 0)
		drawspeed=atoi(&qw[10]);

	  if (strncasecmp(qw,"#KSCAN",6) == 0)
		  kscan=atoi(&qw[6]);

	  if (strncasecmp(qw,"#MAXIPF",7) == 0) {
		  max_ipf=atoi(&qw[7]);
		  oldmax=max_ipf;
	  }

	  if (strncasecmp(qw,"#DEBUG",6) == 0)
		  debug=atoi(&qw[6]);

	  if (strncasecmp(qw,"#v9938",6) == 0)
		  v9938=atoi(&qw[6]);

	  if (strncasecmp(qw,"#speedup_float",14) == 0)
		  speedup_float=atoi(&qw[14]);

	  if (strncasecmp(qw,"#speedup_fr213",14) == 0)
		  speedup_fr213=atoi(&qw[14]);

	  if (strncasecmp(qw,"#disk",5) == 0) {
	    int drive;
	    char *path;
	    char dtype;
	    sscanf(qw+5, "%d %1s %as", &drive, &dtype, &path);
	    if (drive>=1 && drive<=9 && (dtype == 'i' || dtype == 'v' || dtype == 't' || dtype == 'r')) {
	      diskpath[drive] = path;
	      disktype[drive] = dtype;
	      fprintf(stderr, "using path %s type %c as DSK%d.\n", path,
		      dtype, drive);
	    }
	  }
  }
  else
  { if ((flag!=(int)NULL)&&(qw[0]!=';'))
    { type=qw[0];
      address=hex2dec(&qw[2]);
      length=hex2dec(&qw[7]);
      if ((type!='C')&&(type!='X')&&(type!='G')&&(type!='V'))
      { goto skipload;
      }
      index1=12;
      while (qw[++index1]>31);
        qw[index1]=0;
      fp2=fopen(&qw[12],"rb");
      if (fp2==NULL) fail("Can't open specified memory file!");
      
      fprintf(stderr, "module type %c adr %4X len %4X path %s\n",
		      type, address, length, &qw[12]);
	  /*printf("Loading %s to ",&qw[12]);
      switch (type)
      { case 'C': printf("CPU ROM"); break;
        case 'X': printf("XB ROM bank 2"); break;
        case 'G': printf("GROM"); break;
        case 'V': printf("VDP RAM"); break;
      }
      printf(" at >%x, length >%x\n",address,length);*/
      
	  if (qw[6]=='-')
      { /*printf("TIFILES header skip...\n"); */
        for (index1=0; index1<128; index1++)
          fgetc(fp2);   /* skip TIFILES header (128 bytes) */
      }
      if (qw[11]=='-')
      { /*printf("GRAM Kracker header skip...\n"); */
        for (index1=0; index1<6; index1++)
          fgetc(fp2);   /* skip 6 bytes */
      }
      for (index1=0; index1<length; index1++)
      { c=fgetc(fp2);
        switch(type)
        { case 'C': CPU[address+index1]=c;
                    ROMMAP[address+index1]=1;
                    break;
          case 'X': CPU2[(address-0x6000)+index1]=c;
                    xb=1;
                    break;
          case 'G': GROM[address+index1]=c;
                    break;
          case 'V': VDP[address+index1]=c;
                    break;
        }
      }
      fclose(fp2); 
      /*if (d2) printf("\n");*/
    skipload: ;
    }
  }
}
fclose(fp);
}

Word hex2dec(x) char x[];
{ /* convert 4 digit hex to decimal */
Word z,y,i,j;

z=0; j=4096;
for (i=0; i<4; i++)
{ y=x[i]-48;
  if (y>9) y=y-7;
  z=z+(y*j);
  j=j/16;
}
return(z);
}

double tifloat2double(Byte *p) {
  short int firstword;
  int i, exp, sign=1;
  double res;
  
  firstword = *p++ << 8;
  firstword |= *p++;
  if (firstword==0)
	return 0;
  else if (firstword<0) {			/* negative */
	sign=-1;
	firstword = -firstword;
  }
  exp = ((firstword >> 8) - 0x40 - 6) << 1;
  res = firstword & 0xff;
  for (i=0; i<6; i++)
	res = 100*res + *p++;
  return (sign * res * pow(10,exp));
}
	
void double2tifloat(double d, Byte *p) {
  short int firstword;
  int i, exp, sign=1;
  
  if (d==0) {
	*p++ = 0;
	*p = 0;
	return;
  } else if (d<0) {				/* negative */
	sign=-1;
	d = -d;
  }
  exp = (int) log10(d) >> 1;
  d /= pow(10,exp<<1);
  firstword = (exp + 0x40) << 8 | (Byte) d;
  if (sign<0)
	firstword = -firstword;
  *p++ = firstword >> 8;
  *p++ = firstword & 0xff;
  for (i=0; i<6; i++) {
	d = (d - (int) d) * 100;
	*p++ = (Byte) d;
  }
}
	

void do1()
{ /* do one instruction */
Byte x1;
int t1,t2;

cpucount++;

  if (debug)
	draw_debug();			// draw the screen if in debug mode

/******* check for video *****/
if ((retrace_count>drawspeed)||(interrupt_needed)||(last_count!=retrace_count))
{
  if (retrace_count>drawspeed && setpalette_needed)
	VDPsetpalette();

  if ((retrace_count>drawspeed)&&(redraw_needed))	/* only draw if VDP RAM changed & it's time*/
  { VDPdisplay();									/* this skews the accounting a bit, but */
    cpuframes++;				                    /* should help speed a lot.             */
  }

  timercount+=retrace_count;
  if (retrace_count>drawspeed)
	  retrace_count=0;
  last_count=retrace_count;

  instruction_count=0;

  VDPST |= 0x80;			// VDP interrupt has occurred

#if 1
  if ((ST&0x0002)&&(VDPREG[1]&0x20)&&interrupt_needed) { // if interrupt mask on and VDP ints on
	interrupt_needed=0;
	x1=CPU[0x83c2];
	if ((x1&0x80)==0)				/* if console routine on */
	{ /* console routine is active */
	    if ((x1&0x40)==0)
	    {	/* update sprites */

			/* the table offsets are hardcoded in the real TI		*/
			for (num_sprites=0; num_sprites<(CPU[0x837a]); num_sprites++)
			{	offset=num_sprites<<2;
				y_speed=(Byte)VDP[0x780+offset];
				x_speed=(Byte)VDP[0x781+offset];
				t1=(Byte)VDP[0x782+offset];
				t2=(Byte)VDP[0x783+offset];
				t1a=(y_speed&0xf0)>>4;
				t1b=(y_speed&0xf);
				t2a=(x_speed&0xf0)>>4;
				t2b=(x_speed&0xf);
			
				if (t1a>0x7)
				{	t1a-=0xf;
					if (t1b==0)
						t1a-=1;
				}
				if (t2a>0x7)
				{	t2a-=0xf;
					if (t2b==0)
						t2a-=1;
				}
	
				t1b=(y_speed&0xf);
				if ((y_speed>0x7f)&&(t1b))
					t1b=(t1b-0x10);
				if ((x_speed>0x7f)&&(t2b))
					t2b=(t2b-0x10);

				sprite_y=(Byte)VDP[0x300+offset];
				sprite_x=(Byte)VDP[0x301+offset];
				
				ty=sprite_y;
				tx=sprite_x;
			
				t1+=t1b;
				t2+=t2b;

				sprite_y+=t1a;
				sprite_x+=t2a;
	
				if (t1>0xf)
				{	t1-=0xf;
					sprite_y++;
				}
				if (t1<0)
				{	t1+=0xf;
					sprite_y--;
				}

				if (t2>0xf)
				{	t2-=0xf;
					sprite_x++;
				}
				if (t2<0)
				{	t2+=0xf;
					sprite_x--;
				}

				sprite_x&=0xff;
				sprite_y&=0xff;

				if ((sprite_y>=0xc0)&&(sprite_y<=0xe0))
				{	if (y_speed>0x7f)
						sprite_y-=0x20;
					else
						sprite_y+=0x20;
				}
	
				VDP[0x300+offset]=(Byte)sprite_y;
				VDP[0x301+offset]=(Byte)sprite_x;
				VDP[0x782+offset]=(Byte)t1;
				VDP[0x783+offset]=(Byte)t2;
			
				if ((ty!=sprite_y)||(tx!=sprite_x))
					redraw_needed=1;

			}
		}
    
		if ((x1&0x20)==0)
	    { /* update sound list */
	      if (CPU[0x83ce])
		  {		CPU[0x83ce]--;
				if (CPU[0x83ce]==0)
				{	/* update sound list */
					snd_address=romword(0x83cc);
					if (CPU[0x83fd] & 0x01)
					{ /* sound list is in VDP RAM */
					  if (v9938)
						sndlist = &VDP[((VDPREG[14] & 0x07) << 14) |
									  (snd_address&0x3fff)];
					  else
						sndlist=(&VDP[snd_address]);
					} else
					{ /* sound list is in GROM */
						sndlist=(&GROM[snd_address]);
					}
					data=*sndlist++;
					snd_address+=data;
					if ((data!=0)&&(data!=0xff))
					{	while (data--)
						{	wsndbyte(*sndlist++);
						}
						data=*sndlist++;
						snd_address+=2;
						wrword(0x83cc,snd_address);
						CPU[0x83ce]=data;
					}	else
					{	if (data==0xff)
						{	if (CPU[0x83fd] & 0x1)
								CPU[0x83fd]&=0xfe;
							else
								CPU[0x83fd]|=0x01;
						}
						CPU[0x83cc]=*sndlist++;
						CPU[0x83cd]=*sndlist++;
						CPU[0x83ce]=0x01;
					}
				}
		  }
	    }
	
	    if ((x1&0x10)==0)
		{ /* check for QUIT key */
	      if (((key[KEY_ALT])||(key[KEY_ALTGR]))&&(key[KEY_EQUALS]))
		  { while (key[KEY_EQUALS]); /* wait for key release */
		  ST=(ST&0xfff0);		// disable interrupts
			/* Reset - BLWP @>0000 */
	        WP=romword(0x0000);
		    wrword(WP+26,0xffff);
			wrword(WP+28,PC);
	        wrword(WP+30,ST);
		    PC=romword(0x0002);
			grmaccess=0;		// No GROM Access yet
			vdpaccess=0;		// No VDP address writes yet 
			interrupt_needed=0;	// No interrupt missed yet
			firstcolorbyte = -1;
		  }
	    }
	}

	/* the following parts can't be turned off, except by LIMI or disabling VDP ints */
  
  	wrword(0x83d6,romword(0x83d6)+2);	/* this blanks the screen when it */
										/* wraps around to zero */
	
	if (romword(0x83d6)==0)				/* we're wrapped					*/
	{	t1=CPU[0x83d4];					/* read the byte...					*/
		t1=(t1|0x20)&0xbf;				/* int turns ON VDP interrupts, and	*/
										/* turns OFF display bit			*/
		VDPREG[1]=(Byte)t1;				/* write it							*/
	}
  
	CPU[0x8379]+=CPU[0x83fc];			/* VDP Int Timer - not sure how it	*/
										/* gets this, but here it is. Add	*/
										/* byte from R14 of the GPL WP at	*/
										/* >83e0. Can't trace what it is.	*/
										/* E/A manual calls it System Status*/

	CPU[0x837b]=VDPST;		/* VDP Status register - copied to CPU RAM		*/
							/* This is where global sprite COINC goes		*/
	
	if (romword(0x83C4)) 		/* call the user interrupt routine */
	{	/* pretend that we really were called with BLWP by saving the values	*/
		/* into the appropriate workspace (0x83c0)								*/
		wrword(0x83da,WP);		/* WP in R13 */
		wrword(0x83dc,PC);		/* PC in R14 */
		wrword(0x83de,ST);		/* ST in R15 */

		ST=(ST&0xfff0);			/* disable interrupts */

		/* now load the correct workspace, and perform a branch and link to the address */
		WP=0x83e0;				/* interrupt workspace is 0x83e0						*/
		wrword(0x83f6,0x0ab8);	/* write into new R11 hard-coded return address in ROM	*/
		PC=romword(0x83c4);		/* off we go.. TI should return normally now			*/
	}

  }

}

/******* intercept patch for KSCAN *********/

if ((kscan)&&(PC==0x2ba)&&(CPU[0x8374]==0))	/* intercept KSCAN here */
{ 
	/* check keyboard. This is not 100% correct behaviour */

	if (keypressed())
	{	VDPREG[8]=readkey()&0xff;
		clear_keybuf();
	} else
		VDPREG[8]=0xff;

	/* done keyboard */

	CPU[WP]=VDPREG[8];				/* set R0 (byte) with keycode */
	CPU[WP+12]=0;					/* CLR R6 (byte) */
	if (VDPREG[8]!=0xff) 
	{	CPU[WP+12]=0x20;			/* if key pressed, set R6 (for COND bit) */
		VDPREG[8]=0xff;
		VDPREG[1]=CPU[0x83d4];		/* copy VDP status copy in CPU to VDP register 1 */
		wrword(0x83d6,0);			/* clear screen timer */
	}
	PC=0x478;						/* continue here */
}

// Quick hack to force joysticks to work (joystick 1, anyway)
if ((PC==0x478) && (CPU[0x8374]==1))
{
	if (key[KEY_UP])
		CPU[0x8376]=0x04;
	if (key[KEY_DOWN])
		CPU[0x8376]=0xfc;
	if (key[KEY_LEFT])
		CPU[0x8377]=0xfc;
	if (key[KEY_RIGHT])
		CPU[0x8377]=0x04;
}

/******* intercept patch for Ami99 DSK1 emulation ***********/
if (PC==0x4800)						/* special intercept address for emulated ROM */
{
	do_dsrlnk();
	PC=romword(WP+22)+2;			// return address in R11.. TI is a bit silly
									// and if we don't increment by 2, it's considered
									// an error condition
}

if (PC == 0x4810) {			/* powerup */
  wrword(0x8358, 0x3ef5);	/* volume ID block */
  wrword(0x8366, 0x3eea);	/* VDP stack */
  do_files(3);
  PC=romword(WP+22);
}

if (PC>=0x4820 && PC<=0x482c)	/* special intercept address for emulated ROM */
{
	do_sbrlnk();
	PC=romword(WP+22)+2;			// return address in R11.. TI is a bit silly
									// and if we don't increment by 2, it's considered
									// an error condition
}

  if (key[KEY_ESC]) quitflag=0;
  if (key[KEY_PGUP]) Video_Debug=1;
  if (key[KEY_PGDN]) Video_Debug=0;
  if (!debug && key[KEY_HOME])
  {
	debug=1;
	redraw_needed = 1;
	if (!v9938) {
	  fprintf(stderr, "entering debug mode\n");
	  if (set_gfx_mode(GFX_DIRECTX,640,480,0,0)<0)
		fail("Can't set 640x480x8 graphics mode!");
	  clear_keybuf();	/* maybe didnt get release event */
	}
  }

  if (debug && key[KEY_END]) 
  {
	debug=0;
	max_ipf=oldmax;				/* leave stop mode */
	redraw_needed = 1;
	if (!v9938) {
	  fprintf(stderr, "leaving debug mode\n");
	  if (set_gfx_mode(GFX_DIRECTX,320,200,0,0)<0)
		if (set_gfx_mode(GFX_DIRECTX,640,480,0,0)<0)
		  fail("Can't set 320x200x8 or 640x480x8 graphics mode!");
	  clear_keybuf();	/* maybe didnt get release event */
	}
  }
  if ((key[KEY_F3])&&(debug))
  {
	  col++;
	  if (col>56)
		  col=42;
	  while (key[KEY_F3]);
  }
  
		// breakpoint handling
        if (breakpoint==PC)
           max_ipf=0;

		// Single-stepping
		if (debug && key[KEY_F1])
		{	
			if (0 == max_ipf)
			{
				max_ipf=oldmax;
				//				SetWindowText(myWnd, "Ami99");
			}
			else
			{
				max_ipf=0;
				//				SetWindowText(myWnd, "Ami99 - Paused. F1 to Continue, F2 to Step");
			}

			key[KEY_F1]=0;					// I shouldn't do this. Naughty me.
		}
		if (debug && max_ipf==0 && key[KEY_F2])
		{
			instruction_count=-2;			// this will allow 1 instruction to run
			key[KEY_F2]=0;					// naughty me again
		}									// negative 2 because it counts before it checks


if (speedup_fr213) {			/* speedup fractal calculation */
	 if (PC==0xbcd8 && CPU[PC] == 0xc8) {	/* Mandel */
	   double xu = tifloat2double(&CPU[0xf64e]);
	   double yu = tifloat2double(&CPU[0xf65e]);
	   double n = tifloat2double(&CPU[0x8340]);
	   double m = tifloat2double(&CPU[0x8338]);
	   double dx = tifloat2double(&CPU[0x8380]);
	   double dy = tifloat2double(&CPU[0x8388]);
	   double xc = xu + n * dx;
	   double yc = yu + m * dy;
	   double xz=0, yz = 0, xx, yy;
	   int k=0;
	   int kx = (CPU[WP+14]<<8) + CPU[WP+15]; /* R7 */
	   
	   do {
		 k++;
		 xx = xz * xz;
		 yy = yz * yz;
		 if (k > kx)
		   break;
		 yz = 2 * xz * yz - yc;
		 xz = xx - yy - xc;
	   } while (xx+yy < 100);
	   CPU[WP+12] = k >> 8;
	   CPU[WP+13] = k & 0xff;
	   PC=romword(WP+22);			// return address in R11.
	 }

	 if (PC==0xd198 && CPU[PC] == 0x04) { /* Iter */
	   int r0 = romword(WP);
	   int i0 = romword(WP+2);
	   int kx = romword(WP+12);
	   int k=0, rn, in, rq, iq;

	   if (r0 & 0x8000)			/* negative */
		 r0 -= 0x10000;
	   if (i0 & 0x8000)
		 i0 -= 0x10000;
	   rn = r0;
	   in = i0;
	   while(1) {
		 rq = (rn * rn) >> 12;
		 iq = (in * in) >> 12;
		 if (rq + iq >= 0x4000)
		   break;
		 if (++k >= kx)
		   break;
		 in = i0 + ((rn * in) >> 11);
		 rn = r0 + rq - iq;
	   }
	   CPU[WP+12] = k >> 8;
	   CPU[WP+13] = k & 0xff;
	   PC += 4;
	 }

	 if (PC==0xd28a && CPU[PC] == 0x04) { /* Iter32 */
	   long long int r0 = romword(WP+4);
	   long long int i0 = romword(WP);
	   int kx = romword(WP+12);
	   long long int rn, in, rq, iq;
	   int k=0;

	   r0 = (r0 << 16) + romword(WP+6);
	   i0 = (i0 << 16) + romword(WP+2);
	   if (r0 & 0x80000000)			/* negative */
		 r0 -= 0x100000000;
	   if (i0 & 0x80000000)
		 i0 -= 0x100000000;
	   rn = r0;
	   in = i0;
	   while(1) {
		 rq = (rn * rn) >> 28;
		 iq = (in * in) >> 28;
		 if (rq + iq >= 0x40000000)
		   break;
		 if (++k >= kx)
		   break;
		 in = i0 + ((rn * in) >> 27);
		 rn = r0 + rq - iq;
	   }
	   CPU[WP+12] = k >> 8;
	   CPU[WP+13] = k & 0xff;
	   PC += 4;
	 }
} /* speedup_fr213 */

if (speedup_float) 
{									/* speedup floating point operations */
	 if (PC==0x0d80) {					/* ADD */
	   double2tifloat(tifloat2double(&CPU[0x835c]) + tifloat2double(&CPU[0x834a]), &CPU[0x834a]);
	   PC=romword(WP+22);			// return address in R11.
	 }
	 if (PC==0x0d7c) {					/* SUBT */
	   double2tifloat(tifloat2double(&CPU[0x835c]) - tifloat2double(&CPU[0x834a]), &CPU[0x834a]);
	   PC=romword(WP+22);			// return address in R11.
	 }
	 if (PC==0xe88) {					/* MULT */
	   double2tifloat(tifloat2double(&CPU[0x835c]) * tifloat2double(&CPU[0x834a]), &CPU[0x834a]);
	   PC=romword(WP+22);			// return address in R11.
	 }
	 if (PC==0x0ff4) {					/* DIV */
	   double2tifloat(tifloat2double(&CPU[0x835c]) / tifloat2double(&CPU[0x834a]), &CPU[0x834a]);
	   PC=romword(WP+22);			// return address in R11.
	 }
	 if (PC==0x12b8) {					/* CFI */
	   wrword(0x834a, (Word) tifloat2double(&CPU[0x834a]));
	   PC=romword(WP+22);			// return address in R11.
	 }
} /* speedup_float */

  
/*    double d; */
/*    Byte *p, *p1; */

/*    p1 = &CPU[0x834a]; */
/*    for (p=p1; p<p1+8; p++) */
/*  	fprintf(stderr, "%02x ", *p); */
/*    fprintf(stderr, "%f -> ", d=tifloat2double(p1)); */
/*    double2tifloat(d, p1); */
/*    for (p=p1; p<p1+8; p++) */
/*  	fprintf(stderr, "%02x ", *p); */
/*    fprintf(stderr, "%f ADD\n", tifloat2double(p1)); */

/***** end of patches *****/

instruction_count++;

if (instruction_count<max_ipf)
{
	if (X_flag==0)
	{ in=romword(PC);    /* ie: not for an 'x' instruction */
      PC=PC+2;           /* thanks to Jeff Brown for explaining that! */
	}

	/* 'in' now has an instruction to execute */
	(*opcode[in])();
}
else
{
	vsync();	// wait for next
}

} /* end function */


Byte rcpubyte(x) Word x;
{ /* read a byte from CPU memory */
/* TI CPU memory map
>0000 - >1fff  Console ROM
>2000 - >3fff  Low bank RAM
>4000 - >5fff  DSR ROMs
>6000 - >7fff  Cartridge expansion
>8000 - >9fff  Memory-mapped devices & CPU scratchpad
>a000 - >ffff  High bank RAM

All is fine and dandy, except the memory-mapped devices, and the
fact that writing to the cartridge port with XB in places causes
a bank switch. In this emulator, that will only happen if bank 2
has been loaded. A custom DSR will be written to be loaded which
will appear to the "TI" to support all valid devices, and it will
be loaded into the DSR space, which then will not be paged. */

if ((x>0x9fff)||(x<0x4000)) return(CPU[x]);		// normal CPU RAM

if ((x>=0x4000) && (x<=0x5fff)) return(CPU[x]);	// DSR ROM (only 1 implemented)

// XB is supposed to only page the upper 4k, but some other carts seem to like it all
// paged? Dunno.. weird.
 if ((x>=0x6000)&&(x<0x8000)) {
   if ((xb)&&(bank))
	 return(CPU2[x-0x6000]);
   else return(CPU[x]);
 }

if ((x>=0x8000)&&(x<=0x83ff))
{ x=0x8300+(x&0x00ff); /* make sure it maps into >8300->83ff */
  return(CPU[x]);
}

if ((x>=0x8400)&&(x<=0x87ff))
return((Byte)0); /* Reading the sound chip can hang a real TI */

if ((x>=0x8800)&&(x<=0x8fff))
return(rvdpbyte(x));

if ((x>=0x9000)&&(x<=0x97ff))
return((Byte)0); /* speech synthesizer not supported */

if ((x>=0x9800)&&(x<=0x9fff))
return(rgrmbyte(x));

/* Shouldn't be here */
return(0);
}

void wcpubyte(x,c) Word x; Byte c;
{ /* write a byte to CPU memory */

//x&=0xffff;
//c&=0xff;

/* perform XB bank switch */
if ((x>=0x6000)&&(x<0x8000)&&(xb))
  { bank=(x&0x0002)>>1;
    return; 
  }
 
if (ROMMAP[x]) return; /* can't write to ROM! */

if ((x<0x8000)||(x>0x9fff))
{ CPU[x]=c;
  return;
}

if ((x>=0x8000)&&(x<=0x83ff))
{ x=0x8300+(x&0x00ff);
  CPU[x]=c;
  return;
}

if ((x>=0x8400)&&(x<=0x87ff))
{ wsndbyte(c);
  return;
}

if ((x>=0x8800)&&(x<=0x8fff))
{ wvdpbyte(x,c);
  return;
}

if ((x>=0x9000)&&(x<=0x97ff))
return; /* speech synthesizer not supported */

if ((x>=0x9800)&&(x<=0x9fff))
{ wgrmbyte(x,c);
  return;
}
}

void increment_vdpadd(void) {
  if ((++VDPADD & 0x3fff) == 0) { /* increment, handle overflow */
	VDPADD ^= 0x4000;			/* restore bit 14 */
	/* workaround for compatibility problem: inc. bank only in new modes */
	if (mode==G1 || mode==G2 || mode==T1 || mode==MC) {
	  fprintf(stderr, "VDP access: suppessed bank increment at PC 0x%04X\n", PC);
	} else {
	  VDPADD &= 0x4000;
	  VDPREG[14] = (VDPREG[14]+1) & 0x07;
	  fprintf(stderr, "VDP access: bank increment at PC 0x%04X\n", PC);
	}
  }
}

Byte rvdpbyte(x) Word x;
{ /* read a byte of VDP data. CPU address x */
 
  if (x>=0x8c00 || (x&1)) return(0); /* nothing there to read */

  if (v9938) {
	if (x & 2) {				/* read VDP status register */
	  Byte z;
	  Byte s = VDPREG[15] & 0x0f;

	  if (v9938) {
#ifdef v9938debug
		if (s>0)
		  fprintf(stderr, "reading VDP status register %d\n", s);
#endif
		VDPS[1] = VDPS[1] & 0x3f | (mouse_b << 6); /* update mouse buttons - FIXME: check enable */
		if (s==3 || s==5) {		/* get mouse position - FIXME: check enable */
		  int dx, dy;			/* difference of mouse position since last call */
		  get_mouse_mickeys(&dx, &dy); /* get differences since last query */
		  mx+=dx; my+=dy;		/* update positions */
		  if (s==3) {			/* get x difference */
			z = mx - oldmx;
			oldmx = mx;
			return z;
		  } else {				/* get y difference */
			z = my - oldmy;
			oldmy = my;
			return z;
		  }
		}
	  }	/* v9938 */

	  z = VDPS[s];
	  VDPS[s] = 0;
	  return(z);
	} else {					/* read VDP memory */
	  int adr =
		((VDPREG[45] & 0x40) << (17-5)) |
		((VDPREG[14] & 0x07) << 14) |
		VDPADD & 0x3fff;
	  Byte dat = VDP[adr];

	  increment_vdpadd();
	  return(dat);
	}
  } else {						/* v9929 */
	unsigned short z;
	if (x&0x0002)
	  {/* read status */
		z=VDPST;
		VDPST=0;
		return((Byte)z);
	  }
	else
	  { /* read data */
/*  		if (VDPADD>=0x8000)  */
/*  		  { wVDPreg((VDPADD&0x0700)>>8,VDPADD&0x0ff); */
/*  		  return((Byte)0); */
/*  		  } */
/*  		else */
		  { z=VDP[VDPADD&0x3fff];
		  VDPADD++;
		  return ((Byte)z);
		  }
	  }
  }
}

void wvdpbyte(x,c) Word x; Byte c;
{ /* write a byte to VDP. CPU address x           */

  if (x<0x8c00 || (x&1)) return; /* not going to write at that block */

  if (v9938) {
	if ((x&6) == 2) {			/* write VDP address */
	  VDPADD = (VDPADD>>8) | (c<<8);
	  vdpaccess++;
	  if (vdpaccess==2) {
		if (VDPADD & 0x8000) {	/* write VDP register */
		  wVDPreg((Byte)((VDPADD&0x3f00)>>8),(Byte)(VDPADD&0x00ff));
		  //		  redraw_needed=1;
		}
		vdpaccess=0;
	  }
	} else if ((x&6) == 0) {		/* write VDP data */
	  int adr;

	  // undocumented feature: if address not set for writing, inc. address before writing
	  if ((VDPADD & 0x4000) == 0) {
		VDPADD |= 0x4000;
		increment_vdpadd();
	  }
	  adr =
		((VDPREG[45] & 0x40) << (17-5)) |
		((VDPREG[14] & 0x07) << 14) |
		VDPADD & 0x3fff;
	  VDP[adr] = c;
	  increment_vdpadd();
	  // trigger necessary updates
	  if (CTsize)
		if (adr >= CT && adr < CT+CTsize) {
		  redraw_needed = 1;
		  if (mode == G1)
			setpalette_needed = 1;
		}
	  if (SITsize)
		if (adr >= SIT && adr < SIT+SITsize)
		  redraw_needed = 1;
	  if (PDTsize)
		if (adr >= PDT && adr < PDT+PDTsize) {
		  redraw_needed = 1;
		  rebuild_patterns_needed = 1;
		}
	  if (SALsize)
		if (adr >= SAL && adr < SAL+SALsize)
		  redraw_needed = 1;
	  if (SDTsize)
		if (adr >= SDT && adr < SDT+SDTsize)
		  redraw_needed = 1;
	  rebuild_patterns_needed = 1;						/* FIXME: doesnt work :( */
	  //	  redraw_needed = 1;
	} else if ((x&6) == 4) {		/* write VDP color palette */
	  if (firstcolorbyte<0)
		firstcolorbyte = c;
	  else {
		TIPAL[VDPREG[16]&0x0f].r = (firstcolorbyte & 0x70) >> 1;
		TIPAL[VDPREG[16]&0x0f].b = (firstcolorbyte & 0x07) << 3;
		TIPAL[VDPREG[16]&0x0f].g = (c & 0x07) << 3;
		firstcolorbyte = -1;
		setpalette_needed = 1;
#ifdef v9938debug
		fprintf(stderr, "color %d r=%d g=%d b=%d\n",
				VDPREG[16]&0x0f,
				TIPAL[VDPREG[16]&0x0f].r,
				TIPAL[VDPREG[16]&0x0f].g,
				TIPAL[VDPREG[16]&0x0f].b
				);
#endif
	  }
	} else {					/* write VDP register indirect */
	  Byte r = VDPREG[17] & 0x3f;
#ifdef v9938debug
	  fprintf(stderr, "writing VDP register %d=0x%02x indirectly\n",
			  r, c);
#endif
	  if (r != 17) {
		wVDPreg(r, c);
		if ((VDPREG[17] & 0x80) == 0)
		  VDPREG[17] = (VDPREG[17]+1) & ~0x40;
	  }
	}
  } else {						/* v9929 */
	if (x&0x0002)
	  {/* write address */
		VDPADD=(VDPADD>>8)|(c<<8);
		vdpaccess++;
		if (vdpaccess==2)
		  { if (VDPADD&0x8000)
			{ wVDPreg((Byte)((VDPADD&0x0700)>>8),(Byte)(VDPADD&0x00ff));
			redraw_needed=1;
			}
		  vdpaccess=0;
		  }
	  }
	else
	  { /* write data */
		VDP[(VDPADD++)&0x3fff]=c;
		redraw_needed=1;
	  }
  }
}


void pset(int dx, int dy, int c, int a, int l) { /* set pixel */
	 int p, mask, val;			/* VDP base address, mask, value */

	 switch (mode) {
	 case G4: {
	   if (a & 0x20)			/* MXD */
		 dy += 1024;
	   p = (dy<<7) + (dx>>1);
	   mask = (dx&1) ? 0x0f : 0xf0;
	   val = (dx&1) ? c : c<<4;
	 }
	 break;
	 case G5: {
	   if (a & 0x20)			/* MXD */
		 dy += 1024;
	   p = (dy<<7) + (dx>>2);
	   mask = 3 << (6-2*(dx&3));
	   val = c << (6-2*(dx&3));
	 }
	 break;
	 case G6: {
	   if (a & 0x20)			/* MXD */
		 dy += 512;
	   p = (dy<<8) + (dx>>1);
	   mask = (dx&1) ? 0x0f : 0xf0;
	   val = (dx&1) ? c : c<<4;
	 }
	 break;
	 case G7: {
	   if (a & 0x20)			/* MXD */
		 dy += 512;
	   p = (dy<<8) + dx;
	   mask = 0xff;
	   val = c;
	 }
	 break;
	 default:					/* ignore command in other modes */
	   return;
	 } /* switch */

	 val &= mask;

	 if (val || (l&0x08==0))
	   switch (l & 0x07) {
	   case 0:					/* IMP */
		 VDP[p] = VDP[p] & ~mask | val;
		 break;
	   case 1:					/* AND */
		 VDP[p] &= (~mask | val);
		 break;
	   case 2:					/* OR */
		 VDP[p] |= val;
		 break;
	   case 3:					/* EOR */
		 VDP[p] ^= val;
		 break;
	   case 4:					/* NOT */
		 VDP[p] &= (~mask | ~val);
		 break;
	   default:					/* ignore illegal logic */
		 break;
	   } /*  switch l */

	 if (!redraw_needed)
	   if (VDPREG[1] & 0x40) {
		 // redraw only necessary area immediately, if screen on and no redraw coming anyway
		 if (mode==G4)
		   VDPgraphics4(dx&0xfe, dy&0xff, dx&0xfe, dy&0xff);
		 // FIXME: G5 not yet implemented
		 /*  	   else if (mode==G5) */
		 /*  		 VDPgraphics5(dx&0x1fc, dy&0xff, dx&0x1fc, dy&0xff); */
		 else if (mode==G6)
		   VDPgraphics6(dx&0x1fe, (dy&0xff)<<1, dx&0x1fe, (dy&0xff)<<1);
		 else // if (mode==G7)
		   VDPgraphics7((dx&0xff)<<1, (dy&0xff)<<1, (dx&0xff)<<1, (dy&0xff)<<1);
/*  		   VDPgraphics7(dx&0xff, (dy&0xff)<<1, dx&0xff, (dy&0xff)<<1); */
	   }
}


void wVDPreg(r,v) Byte r,v;
{ /* write a value into a VDP register */
  int t;

VDPREG[r]=v;

if (r==7)
{ /* color of screen, set color 0 (trans) to match */
  t=v&0xf;
  TIPAL[0].r=TIPAL[t].r;
  TIPAL[0].g=TIPAL[t].g;
  TIPAL[0].b=TIPAL[t].b;
}

if (r<=1)						/* mode switched */
  mode = ((VDPREG[0]&0x0e)<<1) | ((VDPREG[1]&0x18)>>3);

/* workaround for compatibility problem: higher banks only from user programs */
 if (v9938 && r==2 && PC<0x2000 && v&0xf0) {
   fprintf(stderr, "PC 0x%04X: writing 0x%02x instead of 0x%02x to VDP register 2\n", PC, v&0x0f, v);
   VDPREG[r] = v & 0x0f;
 }
 if (v9938 && r==4 && PC<0x2000 && v&0xf8) {
   fprintf(stderr, "PC 0x%04X: writing 0x%02x instead of 0x%02x to VDP register 4\n", PC, v&0x07, v);
   VDPREG[r] = v & 0x07;
 }

 if (r<=13) {
   gettables();
   redraw_needed=1;
   setpalette_needed = 1;
   rebuild_patterns_needed = 1;
 }

 if (r==46 && ((mode==G4) || (mode==G5) || (mode==G6) || (mode==G7))) {	/* execute command */
   int sx = ((VDPREG[33]&0x01)<<8) | VDPREG[32];
   int sy = ((VDPREG[35]&0x03)<<8) | VDPREG[34];
   int dx = ((VDPREG[37]&0x01)<<8) | VDPREG[36];
   int dy = ((VDPREG[39]&0x03)<<8) | VDPREG[38];
   int nx = ((VDPREG[41]&0x03)<<8) | VDPREG[40]; /* Bit 1+8 also */
   int ny = ((VDPREG[43]&0x03)<<8) | VDPREG[42];
   int c = VDPREG[44];			/* color */
   int a = VDPREG[45];			/* argument */
   int l = v & 0x0f;			/* logical operation */

   switch (v & 0xf0) {			/* command */

	 // POINT
   case 0x40: {					/* POINT */
	 int p, mask, count;			/* VDP base address, mask, shift count */
	 
	 switch (mode) {
	 case G4: {
	   if (a & 0x10)			/* MXD */
		 sy += 1024;
	   p = (sy<<7) + (sx>>1);
	   mask = 0x0f;
	   count = (sx&1) ? 0 : 4;
	 }
	 break;
	 case G5: {
	   if (a & 0x10)			/* MXD */
		 sy += 1024;
	   p = (sy<<7) + (sx>>2);
	   mask = 0x03;
	   count = 6-2*(sx&3);
	 }
	 break;
	 case G6: {
	   if (a & 0x10)			/* MXD */
		 sy += 512;
	   p = (sy<<8) + (sx>>1);
	   mask = 0x0f;
	   count = (sx&1) ? 0 : 4;
	 }
	 break;
	 case G7: {
	   if (a & 0x10)			/* MXD */
		 sy += 512;
	   p = (sy<<8) + sx;
	   mask = 0xff;
	   count = 0;
	 }
	 break;
	 default:					/* ignore command in other modes */
	   return;
	 } /* switch mode */
	 VDPS[7] = (VDP[p] >> count) & mask;
   }
   break;
   
   // PSET
   case 0x50: 					/* PSET */
	 pset(dx, dy, c, a, l);
	 break;
	 
	 // LINE
   case 0x70:					/* LINE */
	 if (nx) {					/* ignore invalid count */
	   int x, y;
	   
	   if (a & 0x01) {			/* y side longer, ny <-> nx! */
		 if (a & 0x08)			/* DY */
		   dy -= (nx-1);
		 if (a & 0x04)			/* DX */
		   dx -= (ny-1);
		 for (y=dy; y<dy+nx; y++)
		   pset(dx + ny * (y-dy) / nx, y, c, a, l);
	   } else {						/* x side longer */
		 if (a & 0x08)			/* DY */
		   dy -= (ny-1);
		 if (a & 0x04)			/* DX */
		   dx -= (nx-1);
		 for (x=dx; x<dx+nx; x++)
		   pset(x, dy + ny * (x-dx) / nx, c, a, l);
	   }
/*  	   fprintf(stderr, "PC 0x%4X: LINE dx=0x%02x dy=0x%02x nx=0x%02x ny=0x%02x c=0x%02x dir=%d\n", */
/*  			   PC, dx, dy, nx, ny, c, a&1); */
	 } /* if nx */
	 break;
	 
	 // HMMV
   case 0xc0: {					/* HMMV */
	 int p, dp, n;				/* VDP base address, increment, number of bytes*/

	 if (a & 0x08)				/* DY */
	   dy -= (ny-1);
	 if (a & 0x04)				/* DX */
	   dx -= (nx-1);

	 switch (mode) {
	 case G4: {
	   p = (dy<<7) + (dx>>1);
	   dp = 128;
	   n = nx>>1;
	 }
	 break;
	 case G5: {
	   p = (dy<<7) + (dx>>2);
	   dp = 128;
	   n = nx>>2;
	 }
	 break;
	 case G6: {
	   p = (dy<<8) + (dx>>1);
	   dp = 256;
	   n = nx>>1;
	 }
	 break;
	 case G7: {
	   p = (dy<<8) + dx;
	   dp = 256;
	   n = nx;
	 }
	 break;
	 default:					/* ignore command in other modes */
	   return;
	 } /* switch mode */
	 
	 if (a & 0x20)				/* MXD */
	   p += 0x20000;

	 fprintf(stderr, "PC 0x%4X: HMMV dx=0x%02x dy=0x%02x nx=0x%02x ny=0x%02x c=0x%02x\n",
			 PC, dx, dy, nx, ny, c);

	 for ( ; ny; ny-- , p+=dp)
	   memset(&VDP[p], c, n);

	 redraw_needed=1;
   }
   break;

	 // HMMM
   case 0xd0: {					/* HMMM */
	 int ps, pd, dp, n;				/* VDP base address source/dest, increment, number of bytes */

	 if (a & 0x08) {			/* DIY */
	   sy -= (ny-1);
	   dy -= (ny-1);
	 }
	 if (a & 0x04) {			/* DIX */
	   sx -= (nx-1);
	   dx -= (nx-1);
	 }

	 switch (mode) {
	 case G4: {
	   ps = (sy<<7) + (sx>>1);
	   pd = (dy<<7) + (dx>>1);
	   dp = 128;
	   n = nx>>1;
	 }
	 break;
	 case G5: {
	   ps = (sy<<7) + (sx>>2);
	   pd = (dy<<7) + (dx>>2);
	   dp = 128;
	   n = nx>>2;
	 }
	 break;
	 case G6: {
	   ps = (sy<<8) + (sx>>1);
	   pd = (dy<<8) + (dx>>1);
	   dp = 256;
	   n = nx>>1;
	 }
	 break;
	 case G7: {
	   ps = (sy<<8) + sx;
	   pd = (dy<<8) + dx;
	   dp = 256;
	   n = nx;
	 }
	 break;
	 default:					/* ignore command in other modes */
	   return;
	 } /* switch mode */

	 if (a & 0x10)				/* MXS */
	   ps += 0x20000;
	 if (a & 0x20)				/* MXD */
	   pd += 0x20000;

	 fprintf(stderr, "PC 0x%4X: HMMM sx=0x%02x sy=0x%02x dx=0x%02x dy=0x%02x nx=0x%02x ny=0x%02x\n",
			 PC, sx, sy, dx, dy, nx, ny);
	 
	 for ( ; ny; ny-- , ps+=dp, pd+=dp)
	   memmove(&VDP[pd], &VDP[ps], n);
	 
	 redraw_needed=1;
   }
   break;

   // unknown
   default:
	 fprintf(stderr, "PC 0x%4X: ignoring unsupported command 0x%02x\n", PC, v);
	 break;
   } /* switch v */
 } /* if r==46 */

#ifdef v9938debug
 if (r>7)
   fprintf(stderr, "writing VDP register %d\n", r);
#endif
}

void wsndbyte(c) Byte c;
{ /* write a byte into the sound processor */
	unsigned int x;
	static int noise_type=1;
	static int freq3=22000;
	/* 'c' contains the byte currently being written to the sound chip	*/
	/* all functions are 1 or 2 bytes long, as follows					*/
	/* BYTE		BIT		PURPOSE											*/
	/*	1		0		always '1'										*/
	/*			1-3		Operation:	000 - tone 1 frequency				*/
	/*								001 - tone 1 volume					*/
	/*								010 - tone 2 frequency				*/
	/*								011 - tone 2 volume					*/
	/*								100 - tone 3 frequency				*/
	/*								101 - tone 3 volume					*/
	/*								110 - noise control					*/
	/*								111 - noise volume					*/
	/*			4-7		Least sig. frequency bits for tone, or volume	*/
	/*					setting (0-F), or type of noise.				*/
	/*					(volume F is off)								*/
	/*					Noise set:	4 - always 0						*/
	/*								5 - 0=periodic noise, 1=white noise */
	/*								6-7 - shift rate from table, or 11	*/
	/*									to get rate from voice 3.		*/
	/*	2		0-1		Always '0'. This byte only used for frequency	*/
	/*			2-7		Most sig. frequency bits						*/
	/* commands are instaneous. I'll use a switch for this.				*/

	switch (c&0xf0)
	{	case 0x80:	/* tone 1 frequency */
					last_byte=c;
					need_byte=1;
					break;			/* we need the next byte */

		case 0x90:	/* tone 1 volume */
					x=(c&0x0f)<<4;
					voice_set_volume(voice[0],0xf0-x);
					break;

		case 0xa0:	/* tone 2 frequency */
					last_byte=c;
					need_byte=2;	/* we need the next byte */
					break;

		case 0xb0:	/* tone 2 volume */
					x=(c&0x0f)<<4;
					voice_set_volume(voice[1],0xf0-x);
					break;

		case 0xc0:	/* tone 3 frequency */
					last_byte=c;
					need_byte=3;	/* we need the next byte */
					break;

		case 0xd0:	/* tone 3 volume */
					x=(c&0x0f)<<4;
					voice_set_volume(voice[2],0xf0-x);
					break;

		case 0xe0:	/* noise channel control */
					x=(c&0x07);		// type of noise
					deallocate_voice(voice[3]);
					voice[3]=allocate_voice(spl[1+x]);
					voice_set_playmode(voice[3], PLAYMODE_LOOP);
					noise_type=x+1;
					voice_start(voice[3]);						/* join in */
					if ((noise_type==4) || (noise_type==8))
					{
						// variable frequency noise
						voice_set_frequency(voice[3],freq3);
					}
					break;

		case 0xf0:	/* noise channel volume */
					x=(c&0x0f)<<4;
					voice_set_volume(voice[3],0xf0-x);
					break;

		default:	if (need_byte)
					{	/* second byte of a frequency input */
						x=( (last_byte&0x0f) | ((c&0x3f)<<4) )+1;	/* frequency value */
						x=(111860/x)*22000;						/* get desired hz*sample rate */
						x/=550;									/* divide by set rate of sample */
						voice_set_frequency(voice[need_byte-1], x);
						if (need_byte==3)
						{
							freq3=x;
							if ((noise_type==4) || (noise_type==8))
							{
								// also set noise channel
								voice_set_frequency(voice[3], freq3);
							}
						}
						need_byte=0;
					}	/* if we didn't need one, ignore it */
					break;
	}

}

Byte rgrmbyte(x) Word x;
{ /* read a byte from GROM */
unsigned int z;

if (x>=0x9c00) return(0); /* no response */
if (x&0x0002)
{ /* read address */
grmaccess=2;
z=(GRMADD&0xff00)>>8;
GRMADD=GRMADD<<8;
GRMADD=GRMADD|(GRMADD>>8);
return((Byte)z);
}
else
{ /* read data */
  grmaccess=2;
  z=grmdata;
  grmdata=GROM[GRMADD++];
  return((Byte)z);
}
}

void wgrmbyte(x,c) Word x; Byte c;
{ /* write a byte to GROM */

if (x<0x9c00) return; /* no response */
if (x&0x0002)
{/* write address */
 GRMADD=(GRMADD<<8)|(c&0x00ff);
 grmaccess--;
 if (grmaccess==0)
 { grmaccess=2;
   grmdata=GROM[GRMADD++];
 }
}
else
{ /* write data */
  /* GROM[GRMADD++]=c;  not just yet... */
  warn("Writing to GROM!!");
}
}

void wcru(ad,bt) Word ad; int bt;
{ /* write a "bit" to CRU */

ad=(ad&0x0fff);  /* get actual CRU line */
if (bt)
	CRU[ad]=1;
else
	CRU[ad]=0;

}

int rcru(ad) Word ad;
{ /* read a "bit" from CRU. Zero is true */

	int ret,col;

	/* only certain CRU bits are implemented, check them */

	ad=(ad&0x0fff); 
	
	/* default return code */
	ret=1;

	/* keyboard/joystick. PC Keyboard is currently *NOT* remapped		*/
	/* so that it's keys work.	Joysticks are very badly whacked		*/
	
	/* keyboard reads as an array. Bits 24, 26 and 28 set the line to	*/
	/* scan (columns). Bits 6-14 are used for return. 0 means on.		*/
	/* The address was divided by 2 before being given to the routine	*/

	if ((ad>=0x03)&&(ad<=0x0a))
	{	
		if ((ad==0x07)&&(CRU[0x15]==0))
		{	ret=1;
			if (key_shifts & KB_CAPSLOCK_FLAG)	/* check CAPS LOCK */
			{	ret=0;							/* Alpha Lock off */
			}
		}
		else
		{
			col=(CRU[0x14]==0 ? 1 : 0) | (CRU[0x13]==0 ? 2 : 0) | (CRU[0x12]==0 ? 4 : 0);

			if ((col == 0) || (col == 4))
			{	// joysticks are weird
				if (ad == 3)
				{	// joystick BUTTON is read normally
					if (key[KEYS[col][0]])
						ret=0;
				}
				else
				{
					if (!key[KEYS[col][ad-3]])
					{	ret=0;
					}
				}
			}
			else
			{
				if (key[KEYS[col][ad-3]])
				{	ret=0;				/* true */
				}
			}

		}
	}
	// are we checking VDP interrupt?
	if (ad == 0x02)
	  ret=0;											// that's the only int we have
	
	// no other devices at this time
	
	return(ret);
}

/* one function for each opcode (the mneumonic prefixed with "op_") */

void fixDS()
{ /* fix up D(est) and S(ource) based on Td (type) and Ts */
Word temp,t2;

switch (Ts)
{ case 0: S=WP+(S<<1); break;  /* register */
  case 1: S=romword(WP+(S<<1)); break; /* register indirect */
  case 2: if (S)
          { S=romword(PC)+romword(WP+(S<<1)); PC+=2;} /* indexed */
          else
          { S=romword(PC); PC+=2; } /* symbolic */
          break;
  case 3: t2=WP+(S<<1); temp=romword(t2); wrword(t2,temp+(2-B));
          S=temp; break;     /* register indirect autoincrement */
}

switch (Td)
{ case 0: D=WP+(D<<1); break;   /* register */
  case 1: D=romword(WP+(D<<1)); break; /* register indirect */
  case 2: if (D)
          { D=romword(PC)+romword(WP+(D<<1)); PC+=2;} /* indexed */
          else
          { D=romword(PC); PC+=2; } /* symbolic */
          break;
  case 3: t2=WP+(D<<1); temp=romword(t2); wrword(t2,temp+(2-B));
          D=temp; break;    /* register indirect autoincrement */
}
}

/* Note: the format code letters are the official notation from Texas */
/* instruments. See their TMS9900 documentation for details. */
/* (Td, Ts, D, S, B, etc) */

void parity(x) Byte x;
{ /* count parity and set parity bit in ST */

#if 1
  int z;
  for (z=0; x; x&=(x-1))
    z++;
#else 
int z,y;
  z=0;
  for (y=0; y<8; y++)
  { if (x>127) z=z++;
    x=x<<1;
  }
#endif
  if (z&1) set_OP; else reset_OP;
}


////////////////////////////////////////////////////////////////////
// Ami99 - 9900 CPU opcodes
// Opcode functions follow
// one function for each opcode (the mneumonic prefixed with "op_")
// src - source address (register or memory - valid types vary)
// dst - destination address
// imm - immediate value
// dsp - relative displacement
////////////////////////////////////////////////////////////////////
void op_a()
{
	// Add words: A src, dst

	Word x1,x2,x3;

	FormatI;
	x1=romword(S); 
	x2=romword(D);

	x3=x2+x1; 
	wrword(D,(Word)x3);
																						// most of these are the same for every opcode.
	reset_EQ_LGT;																		// We come out with either EQ or LGT, never both
	if (x3) set_LGT; else set_EQ;														// if not zero, set LGT, else set EQ
	if ((x3)&&(x3<0x8000)) set_AGT; else reset_AGT;										// if not zero and not negative, set AGT
	if (x3<x2) set_C; else reset_C;														// if it wrapped around, set carry
	if (((x1&0x8000)==(x2&0x8000))&&((x3&0x8000)!=(x2&0x8000))) set_OV; else reset_OV;	// if it overflowed or underflowed (signed math), set overflow
}

void op_ab()
{ 
	// Add bytes: A src, dst
	
	Byte x1,x2,x3;

	FormatI;
	x1=rcpubyte(S); 
	x2=rcpubyte(D);

	x3=x2+x1;
	wcpubyte(D,x3);
	
	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x80)) set_AGT; else reset_AGT;										// Byte operation, so the overflow values are smaller
	if (x3<x2) set_C; else reset_C;
	if (((x1&0x80)==(x2&0x80))&&((x3&0x80)!=(x2&0x80))) set_OV; else reset_OV;
	parity(x3);																			// Byte operations usually check and affect the odd parity bit
}

void op_abs()
{ 
	// ABSolute value: ABS src
	
	Word x1,x2;

	FormatVI;
	x1=x2=romword(S);

	if (x1&0x8000) x2=~x1+1;															// if negative, make positive
	wrword(S,x2);

	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;														// these are set based on the source
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
	if (x1==0x8000) set_OV; else reset_OV;												// this is the only possible overflow value
}

void op_ai()
{ 
	// Add Immediate: AI src, imm
	
	Word x1,x3;

	FormatVIII_1;
	x1=romword(D);

	x3=x1+S;
	wrword(D,x3);

	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x8000)) set_AGT; else reset_AGT;
	if (x3<x1) set_C; else reset_C;
	if (((x1&0x8000)==(S&0x8000))&&((x3&0x8000)!=(S&0x8000))) set_OV; else reset_OV;
}

void op_dec()
{ 
	// DECrement: DEC src
	
	Word x1;

	FormatVI;
	x1=romword(S);

	x1--;
	wrword(S,x1);

	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
	if (x1!=0xffff) set_C; else reset_C;
	if (x1==0x7fff) set_OV; else reset_OV;
}

void op_dect()
{ 
	// DECrement by Two: DECT src
	
	Word x1;

	FormatVI;
	x1=romword(S);

	x1-=2;
	wrword(S,x1);
	
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
	if (x1<0xfffe) set_C; else reset_C;
	if ((x1==0x7fff)||(x1=0x7ffe)) set_OV; else reset_OV;
}

void op_div()
{ 
	// DIVide: DIV src, dst
	// Dest, a 2 word number, is divided by src. The result is stored as two words at the dst:
	// the first is the whole number result, the second is the remainder

	Word x1,x2; 
	unsigned long x3;

	FormatIX;
	x2=romword(S);
	D=WP+(D<<1);
	x3=romword(D);

	if (x2>x3)														// TODO: this doesn't make sense.. look this up?
	{ 
		x3=(x3<<16)+romword(D+2);
		x1=(Word)(x3/x2);		/* braces! */
		wrword(D,x1);
		x1=(Word)(x3%x2);		/* braces! */
		wrword(D+2,x1);
		reset_OV;
	}
	else
	{
		set_OV;														// division wasn't possible. Do we need to store anything?
	}
}

void op_inc()
{ 
	// INCrement: INC src
	
	Word x1;

	FormatVI;
	x1=romword(S);
	
	x1++;
	wrword(S,x1);
	
	ST=ST&0x4fff;													// reset EQ, LGT, C
	if (x1) set_LGT; else { set_EQ; set_C; }
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
	if (x1==0x8000) set_OV; else reset_OV;
}

void op_inct()
{ 
	// INCrement by Two: INCT src
	
	Word x1;

	FormatVI;
	x1=romword(S);
	
	x1+=2;
	wrword(S,x1);
	
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
	if (x1<2) set_C; else reset_C;
	if ((x1==0x8000)||(x1==0x8001)) set_OV; else reset_OV;
}

void op_mpy()
{ 
	// MultiPlY: MPY src, dst
	// Multiply src by dest and store 32-bit result

	Word x1; 
	unsigned long x3;

	FormatIX;
	x1=romword(S);
	
	D=WP+(D<<1);
	x3=romword(D);
	x3=x3*x1;
	wrword(D,(Word)(x3>>16)); 
	wrword(D+2,(Word)(x3&0xffff));
}

void op_neg()
{ 
	// NEGate: NEG src

	Word x1,x2;

	FormatVI;
	x1=x2=romword(S);

	x1=~x1+1;
	wrword(S,x1);

	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
	if (x2==0x8000) set_OV; else reset_OV;
}

void op_s()
{ 
	// Subtract: S src, dst

	Word x1,x2,x3;

	FormatI;
	x1=romword(S); 
	x2=romword(D);

	x3=x2-x1;
	wrword(D,x3);

	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x8000)) set_AGT; else reset_AGT;
	if (x3<=x2) set_C; else reset_C;
	if (((x1&0x8000)!=(x2&0x8000))&&((x3&0x8000)!=(x2&0x8000))) set_OV; else reset_OV;
}

void op_sb()
{ 
	// Subtract Byte: SB src, dst

	Byte x1,x2,x3;

	FormatI;
	x1=rcpubyte(S); 
	x2=rcpubyte(D);

	x3=x2-x1;
	wcpubyte(D,x3);

	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x80)) set_AGT; else reset_AGT;
	if (x3<=x2) set_C; else reset_C;
	if (((x1&0x80)!=(x2&0x80))&&((x3&0x80)!=(x2&0x80))) set_OV; else reset_OV;
	parity(x3);
}

void op_b()
{ 
	// Branch: B src
	// Unconditional absolute branch

	FormatVI;
	PC=S;
}

void op_bl()
{	
	// Branch and Link: BL src
	// Essentially a subroutine jump - return address is stored in R11
	// Note there is no stack, and no official return function.
	// A return is simply B *R11. Some assemblers define RT as this.

	FormatVI;
	wrword(WP+22,PC);
	PC=S;
}

void op_blwp()
{ 
	// Branch and Load Workspace Pointer: BLWP src
	// A context switch. The src address points to a 2 word table.
	// the first word is the new workspace address, the second is
	// the address to branch to. The current Workspace Pointer,
	// Program Counter (return address), and Status register are
	// stored in the new R13, R14 and R15, respectively
	// Return is performed with RTWP

	Word x1;

	FormatVI;
	x1=WP;
	WP=romword(S);
	wrword(WP+26,x1);
	wrword(WP+28,PC);
	wrword(WP+30,ST);
	PC=romword(S+2);
}

void op_jeq()
{ 
	// Jump if equal: JEQ dsp
	// Conditional relative branch. The displacement is a signed byte representing
	// the number of words to branch

	char x1;

	FormatII;
	x1=(char)D;
	if (ST_EQ) 
	{
		PC+=x1+x1;
	}
}

void op_jgt()
{ 
	// Jump if Greater Than: JGT dsp

	char x1; 

	FormatII;
	x1=(char)D;
	if (ST_AGT) 
	{
		PC+=x1+x1;
	}
}

void op_jhe()
{ 
	// Jump if High or Equal: JHE dsp

	char x1;

	FormatII;
	x1=(char)D;
	if ((ST_LGT)||(ST_EQ)) 
	{
		PC+=x1+x1;
	}
}

void op_jh()
{ 
	// Jump if High: JH dsp
	
	char x1;

	FormatII;
	x1=(char)D;
	if ((ST_LGT)&&(!ST_EQ)) 
	{
		PC+=x1+x1;
	}
}

void op_jl()
{
	// Jump if Low: JL dsp

	char x1;

  	FormatII;
	x1=(char)D;
	if ((!ST_LGT)&&(!ST_EQ)) 
	{
		PC+=x1+x1;
	}
}

void op_jle()
{ 
	// Jump if Low or Equal: JLE dsp

	char x1;

	FormatII;
	x1=(char)D;
	if ((!ST_LGT)||(ST_EQ)) 
	{
		PC+=x1+x1;
	}
}

void op_jlt()
{ 
	// Jump if Less Than: JLT dsp

	char x1;

	FormatII;
	x1=(char)D;
	if ((!ST_AGT)&&(!ST_EQ)) 
	{
		PC+=x1+x1;
	}
}

void op_jmp()
{ 
	// JuMP: JMP dsp
	// (unconditional)
	
	char x1;

	FormatII;
	x1=(char)D;
	PC+=x1+x1;
}

void op_jnc()
{ 
	// Jump if No Carry: JNC dsp
	
	char x1;

	FormatII;
	x1=(char)D;
	if (!ST_C) 
	{
		PC+=x1+x1;
	}
}

void op_jne()
{ 
	// Jump if Not Equal: JNE dsp

	char x1;

	FormatII;
	x1=(char)D;
	if (!ST_EQ) 
	{
		PC+=x1+x1;
	}
}

void op_jno()
{ 
	// Jump if No Overflow: JNO dsp

	char x1;

	FormatII;
	x1=(char)D;
	if (!ST_OV) 
	{
		PC+=x1+x1;
	}
}

void op_jop()
{ 
	// Jump on Odd Parity: JOP dsp

	char x1;

	FormatII;
	x1=(char)D;
	if (ST_OP) 
	{
		PC+=x1+x1;
	}
}

void op_joc()
{ 
	// Jump On Carry: JOC dsp

	char x1;

	FormatII;
	x1=(char)D;
	if (ST_C) 
	{
		PC+=x1+x1;
	}
}

void op_rtwp()
{ 
	// ReTurn with Workspace Pointer: RTWP
	// The matching return for BLWP, see BLWP for description

	ST=romword(WP+30);
	PC=romword(WP+28);
	WP=romword(WP+26);
}

void op_x()
{ 
	// eXecute: X src
	// The argument is interpreted as an instruction and executed
	// I'm not sure how well this works or how often it's used.

	if (X_flag!=0) 
	{
		warn("Recursive X instruction!!!!!");					// X is not allowed to recurse. I don't know if this is true, but it's important here
	}
  
	FormatVI;
	in=romword(S);
	X_flag=1;													// set flag
	do1();														// do an instruction
	X_flag=0;													// clear flag
}

void op_xop()
{ 
	// eXtended OPeration: XOP src ???
	// The CPU maintains a jump table starting at 0x0040, containing BLWP style
	// jumps for each operation. In addition, the new R11 gets a copy of ???
	// Apparently not all consoles (CPUs?) supported this
	// so it is probably rarely, if ever, used on the TI99.
	
	// TODO: this does set the Status X bit.. but how do we know when to turn it off? RTWP?
	// need to look into this instruction. What's the maximum offset?

	Word x1;

	debug_write("Executing XOP");

	FormatIX;
	x1=WP;
	set_X;
	WP=romword(0x0040+(D<<2));
	wrword(WP+22,S);
	wrword(WP+26,x1);
	wrword(WP+28,PC);
	wrword(WP+30,ST);
	PC=romword(0x0042+(D<<2));
}

void op_c()
{ 
	// Compare words: C src, dst
	
	short x1,x2; 
	Word x3,x4;

	FormatI;
	x3=romword(S); 
	x1=x3;
	x4=romword(D); 
	x2=x4;
  
	if (x3>x4) set_LGT; else reset_LGT;
	if (x1>x2) set_AGT; else reset_AGT;
	if (x3==x4) set_EQ; else reset_EQ;
}

void op_cb()
{ 
	// Compare Bytes: CB src, dst
	
	char x1,x2; 
	Byte x3,x4;

	FormatI;
	x3=rcpubyte(S); 
	x1=x3;
	x4=rcpubyte(D); 
	x2=x4;
  
	if (x3>x4) set_LGT; else reset_LGT;
	if (x1>x2) set_AGT; else reset_AGT;
	if (x3==x4) set_EQ; else reset_EQ;
	parity(x3);
}

void op_ci()
{ 
	// Compare Immediate: CI src, imm
	
	short x1,x2; 
	Word x3;

	FormatVIII_1;
	x3=romword(D); 
	x1=x3;
	x2=S;
  
	if (x3>S) set_LGT; else reset_LGT;
	if (x1>x2) set_AGT; else reset_AGT;
	if (x3==S) set_EQ; else reset_EQ;
}

void op_coc()
{ 
	// Compare Ones Corresponding: COC src, dst
	// Basically comparing against a mask, if all set bits in the src match
	// set bits in the dest (mask), the equal bit is set

	Word x1,x2,x3;

	FormatIII;
	x1=romword(S);
	x2=romword(D);
	
	x3=x1&x2;
  
	if (x3==x1) set_EQ; else reset_EQ;
}

void op_czc()
{ 
	// Compare Zeros Corresponding: CZC src, dst
	// The opposite of COC. Each set bit in the dst (mask) must
	// match up with a zero bit in the src to set the equals flag

	Word x1,x2,x3;

	FormatIII;
	x1=romword(S);
	x2=romword(D);
	
	x3=x1&x2;
  
	if (x3==0) set_EQ; else reset_EQ;
}

void op_ldcr()
{ 
	// LoaD CRu - LDCR src, dst
	// Writes dst bits serially out to the CRU registers
	// The CRU is the 9901 Communication chip, tightly tied into the 9900.
	// It's serially accessed and has 4096 single bit IO registers.
	// It's stupid and thinks 0 is true and 1 is false.
	// All addresses are offsets from the value in R12, which is divided by 2

	Word x1,x3; 
	int x2;

	FormatIV;
	if (D==0) D=16;
	if ((S&1)&&(D>8)) S-=1;
	x1=(D<9 ? rcpubyte(S) : romword(S));
  
	x3=1;
	for (x2=0; x2<D; x2++)
	{ 
		wcru((romword(WP+24)>>1)+x2, (x1&x3) ? 1 : 0);
		x3=x3<<1;
	}
  
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<(D<9 ? 0x80 : 0x8000))) set_AGT; else reset_AGT;
	if (D<9) parity(x1&0xff);
}

void op_sbo()
{ 
	// Set Bit On: SBO src
	// Sets a bit in the CRU

	char x1;

	FormatII;
	x1=(char)D;
	wcru((romword(WP+24)>>1)+x1,1);
}

void op_sbz()
{ 
	// Set Bit Zero: SBZ src
	// Zeros a bit in the CRU

	char x1;

	FormatII;
	x1=(char)D;
	wcru((romword(WP+24)>>1)+x1,0);
}

void op_stcr()
{ 
	// STore CRU: STCR src, dst
	// Stores dst bits from the CRU into src

	Word x1,x3,x4; 
	int x2;

	FormatIV;
	if (D==0) D=16;
	if ((S&1)&&(D>8)) S=S-1;
	x1=0; x3=1;
  
	for (x2=0; x2<D; x2++)
	{ 
		x4=rcru((romword(WP+24)>>1)+x2);
		if (x4) 
		{
			x1=x1|x3;
		}
		x3=x3<<1;
	}

	if (D<9) 
    {
		wcpubyte(S,(Byte)x1);  
	}
	else 
    {
		wrword(S,x1);
	}

	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<(D<9 ? 0x80 : 0x8000))) set_AGT; else reset_AGT;
	if (D<9) parity((x1&0xff00)>>8);
}

void op_tb()
{ 
	// Test Bit: TB src
	// Tests a CRU bit

	char x1;

	FormatII;
	x1=(char)D;

	if (rcru((romword(WP+24)>>1)+x1)) set_EQ; else reset_EQ;
}

// These instructions are valid 9900 instructions but are invalid on the TI-99, as they generate
// improperly decoded CRU instructions.

void op_ckof()
{ 
	warn("ClocK OFf instruction encountered!");					// not supported on 99/4A
}

void op_ckon()
{ 
	warn("ClocK ON instruction encountered!");					// not supported on 99/4A
}

void op_idle()
{
	warn("IDLE instruction encountered!");						// not supported on 99/4A
}

void op_rset()
{
	warn("ReSET instruction encountered!");						// not supported on 99/4A
}

void op_lrex()
{
	warn("Load or REstart eXecution instruction encountered!");	// not supported on 99/4A
}

void op_li()
{
	// Load Immediate: LI src, imm

	FormatVIII_1;
	wrword(D,S);
	
	reset_EQ_LGT;
	if (S) set_LGT; else set_EQ;
	if ((S)&&(S<0x8000)) set_AGT; else reset_AGT;
}

void op_limi()
{ 
	// Load Interrupt Mask Immediate: LIMI imm
	// Sets the CPU interrupt mask

	FormatVIII_1;
	ST=(ST&0xfff0)|(S&0xf);
}

void op_lwpi()
{ 
	// Load Workspace Pointer Immediate: LWPI imm
	// changes the Workspace Pointer

	FormatVIII_1;
	WP=S;
}

void op_mov()
{ 
	// MOVe words: MOV src, dst

	Word x1;

	FormatI;
	x1=romword(S);
	
	wrword(D,x1);
  
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
}

void op_movb()
{ 
	// MOVe Bytes: MOVB src, dst

	Byte x1;

	FormatI;
	x1=rcpubyte(S);
	
	wcpubyte(D,x1);
	
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x80)) set_AGT; else reset_AGT;
	parity(x1);
}

void op_stst()
{ 
	// STore STatus: STST src
	// Copy the status register to memory

	FormatVIII_0;
	wrword(D,ST);
}

void op_stwp()
{ 
	// STore Workspace Pointer: STWP src
	// Copy the workspace pointer to memory

	FormatVIII_0;
	wrword(D,WP);
}

void op_swpb()
{ 
	// SWaP Bytes: SWPB src
	// swap the high and low bytes of a word

	Word x1,x2;

	FormatVI;
	x1=romword(S);

	x2=((x1&0xff)<<8)|((x1&0xff00)>>8);
	wrword(S,x2);
}

void op_andi()
{ 
	// AND Immediate: ANDI src, imm

	Word x1,x2;

	FormatVIII_1;
	x1=romword(D);
	x2=x1&S;
	
	wrword(D,x2);
	
	reset_EQ_LGT;
	if (x2) set_LGT; else set_EQ;
	if ((x2)&&(x2<0x8000)) set_AGT; else reset_AGT;
}

void op_ori()
{ 
	// OR Immediate: ORI src, imm

	Word x1,x2;

	FormatVIII_1;
	x1=romword(D);
  
	x2=x1|S;
	wrword(D,x2);
  
	reset_EQ_LGT;
	if (x2) set_LGT; else set_EQ;
	if ((x2)&&(x2<0x8000)) set_AGT; else reset_AGT;
}

void op_xor()
{ 
	// eXclusive OR: XOR src, dst

	Word x1,x2,x3;

	FormatIII;
	x1=romword(S);
	x2=romword(D);
  
	x3=x1^x2;
	wrword(D,x3);
  
	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x8000)) set_AGT; else reset_AGT;
}

void op_inv()
{ 
	// INVert: INV src

	Word x1;

	FormatVI;
	x1=romword(S);
  
	x1=~x1;
	wrword(S,x1);
  
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
}

void op_clr()
{ 
	// CLeaR: CLR src
	// sets word to 0

	FormatVI;
	wrword(S,0);
}

void op_seto()
{ 
	// SET to One: SETO src
	// sets word to 0xffff

	FormatVI;
	wrword(S,0xffff);
}

void op_soc()
{ 
	// Set Ones Corresponding: SOC src, dst
	// Essentially performs an OR - setting all the bits in dst that
	// are set in src

	Word x1,x2,x3;

	FormatI;
	x1=romword(S);
	x2=romword(D);
  
	x3=x1|x2;
	wrword(D,x3);
  
	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x8000)) set_AGT; else reset_AGT;
}

void op_socb()
{ 
	// Set Ones Corresponding, Byte: SOCB src, dst

	Byte x1,x2,x3;

	FormatI;
	x1=rcpubyte(S);
	x2=rcpubyte(D);
  
	x3=x1|x2;
    wcpubyte(D,x3);

	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x80)) set_AGT; else reset_AGT;
	parity(x3);
}

void op_szc()
{ 
	// Set Zeros Corresponding: SZC src, dst
	// Zero all bits in dest that are zeroed in src

	Word x1,x2,x3;

	FormatI;
	x1=romword(S);
	x2=romword(D);
  
	x3=(~x1)&x2;
	wrword(D,x3);
  
	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x8000)) set_AGT; else reset_AGT;
}

void op_szcb()
{ 
	// Set Zeros Corresponding, Byte: SZCB src, dst

	Byte x1,x2,x3;

	FormatI;
	x1=rcpubyte(S);
	x2=rcpubyte(D);
  
	x3=(~x1)&x2;
	wcpubyte(D,x3);

	reset_EQ_LGT;
	if (x3) set_LGT; else set_EQ;
	if ((x3)&&(x3<0x80)) set_AGT; else reset_AGT;
	parity(x3);
}

void op_sra()
{ 
	// Shift Right Arithmetic: SRA src, dst
	// For the shift instructions, a count of '0' means use the
	// value in register 0. If THAT is zero, the count is 16.
	// The arithmetic operations preserve the sign bit

	Word x1,x3,x4; 
	int x2;

	FormatV;
	if (D==0)
	{ 
		D=romword(WP) & 0xf;
		if (D==0) D=16;
	}
	x1=romword(S);
	x4=x1&0x8000;
  
	for (x2=0; x2<D; x2++)
	{ 
		x3=x1&1;   /* save carry */
	    x1=x1>>1;  /* shift once */
	    x1=x1|x4;  /* extend sign bit */
	}
	wrword(S,x1);
  
	if (x3) set_C; else reset_C;
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
}

void op_srl()
{ 
	// Shift Right Logical: SRL src, dst
	// The logical shifts do not preserve the sign

	Word x1,x3; 
	int x2;

	FormatV;
	if (D==0)
	{ 
		D=romword(WP)&0xf;
		if (D==0) D=16;
	}
	x1=romword(S);
  
	for (x2=0; x2<D; x2++)
	{ 
		x3=x1&1;
	    x1=x1>>1;
	}
	wrword(S,x1);

	if (x3) set_C; else reset_C;
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
}

void op_sla()
{ 
	// Shift Left Arithmetic: SLA src, dst

	Word x1,x3,x4; 
	int x2;

	FormatV;
	if (D==0)
	{ 
		D=romword(WP)&0xf;
		if (D==0) D=16;
	}
	x1=romword(S);
	x4=x1&0x8000;
  
	for (x2=0; x2<D; x2++)
	{ 
		x3=x1&0x8000;
		x1=x1<<1;
	}
	wrword(S,x1);
  
	if (x3) set_C; else reset_C;
	if (x4!=(x1&0x8000)) set_OV; else reset_OV;
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
}

void op_src()
{ 
	// Shift Right Circular: SRC src, dst
	// Circular shifts pop bits off one end and onto the other
	// The carry bit is not a part of these shifts

	// TODO: should it be?

	Word x1,x3,x4; 
	int x2;

	FormatV;
	if (D==0)
	{ 
		D=romword(WP)&0xf;
		if (D==0) D=16;
	}
	x1=romword(S);
	for (x2=0; x2<D; x2++)
	{ 
		x3=x1&0x8000;
		x4=x1&0x1;
		x1=x1>>1;
		if (x4) 
		{
			x1=x1|0x8000;
		}
	}
	wrword(S,x1);
  
	if (x3) set_C; else reset_C;
	reset_EQ_LGT;
	if (x1) set_LGT; else set_EQ;
	if ((x1)&&(x1<0x8000)) set_AGT; else reset_AGT;
}

void op_bad()
{ 
	warn("Illegal opcode!");								// Don't know this Opcode
}


void buildcpu()
{ /* set up the CPU array */
Word in,x;
unsigned int i;

/*printf("\nBuilding TMS9900 instruction table\n");*/

for (i=0; i<65536; i++)
{ in=(Word)i;

/*if ((i/820)*820==i) printf(".");*/

/* 'in' now has an instruction to parse. break it down! */

x=(in&0xf000)>>12;

switch(x)
{ case 0: opcode0(in); break;
  case 1: opcode1(in); break;
  case 2: opcode2(in); break;
  case 3: opcode3(in); break;
  case 4: opcode[in]=op_szc; break;
  case 5: opcode[in]=op_szcb; break;
  case 6: opcode[in]=op_s; break;
  case 7: opcode[in]=op_sb; break;
  case 8: opcode[in]=op_c; break;
  case 9: opcode[in]=op_cb; break;
  case 10:opcode[in]=op_a; break;
  case 11:opcode[in]=op_ab; break;
  case 12:opcode[in]=op_mov; break;
  case 13:opcode[in]=op_movb; break;
  case 14:opcode[in]=op_soc; break;
  case 15:opcode[in]=op_socb; break;
  default: opcode[in]=op_bad;
} /*switch*/
} /* for */

/*printf("\n");*/
} /* fctn */

void opcode0(Word in)
{ /* lots of these. Break it again */
unsigned short x;

x=(in&0x0f00)>>8;

switch(x)
{ case 2: opcode02(in); break;
  case 3: opcode03(in); break;
  case 4: opcode04(in); break;
  case 5: opcode05(in); break;
  case 6: opcode06(in); break;
  case 7: opcode07(in); break;
  case 8: opcode[in]=op_sra; break;
  case 9: opcode[in]=op_srl; break;
  case 10:opcode[in]=op_sla; break;
  case 11:opcode[in]=op_src; break;
  default: opcode[in]=op_bad;
}}

void opcode02(Word in)
{ /* more breaking up the opcode */
unsigned short x;

x=(in&0x00e0)>>4;

switch(x)
{ case 0: opcode[in]=op_li; break;
  case 2: opcode[in]=op_ai; break;
  case 4: opcode[in]=op_andi; break;
  case 6: opcode[in]=op_ori; break;
  case 8: opcode[in]=op_ci; break;
  case 10:opcode[in]=op_stwp; break;
  case 12:opcode[in]=op_stst; break;
  case 14:opcode[in]=op_lwpi; break;
  default: opcode[in]=op_bad;
}}

void opcode03(Word in)
{ unsigned short x;

x=(in&0x00e0)>>4;

switch(x)
{ case 0: opcode[in]=op_limi; break;
  case 4: opcode[in]=op_idle; break;
  case 6: opcode[in]=op_rset; break;
  case 8: opcode[in]=op_rtwp; break;
  case 10:opcode[in]=op_ckon; break;
  case 12:opcode[in]=op_ckof; break;
  case 14:opcode[in]=op_lrex; break;
  default: opcode[in]=op_bad;
}}

void opcode04(Word in)
{ unsigned short x;

x=(in&0x00c0)>>4;

switch(x)
{ case 0: opcode[in]=op_blwp; break;
  case 4: opcode[in]=op_b; break;
  case 8: opcode[in]=op_x; break;
  case 12:opcode[in]=op_clr; break;
  default: opcode[in]=op_bad;
}}

void opcode05(Word in)
{ unsigned short x;

x=(in&0x00c0)>>4;

switch(x)
{ case 0: opcode[in]=op_neg; break;
  case 4: opcode[in]=op_inv; break;
  case 8: opcode[in]=op_inc; break;
  case 12:opcode[in]=op_inct; break;
  default: opcode[in]=op_bad;
}}

void opcode06(Word in)
{ unsigned short x;

x=(in&0x00c0)>>4;

switch(x)
{ case 0: opcode[in]=op_dec; break;
  case 4: opcode[in]=op_dect; break;
  case 8: opcode[in]=op_bl; break;
  case 12:opcode[in]=op_swpb; break;
  default: opcode[in]=op_bad;
}}

void opcode07(Word in)
{ unsigned short x;

x=(in&0x00c0)>>4;

switch(x)
{ case 0: opcode[in]=op_seto; break;
  case 4: opcode[in]=op_abs; break;
  default: opcode[in]=op_bad;
}}

void opcode1(Word in)
{ unsigned short x;

x=(in&0x0f00)>>8;

switch(x)
{ case 0: opcode[in]=op_jmp; break;
  case 1: opcode[in]=op_jlt; break;
  case 2: opcode[in]=op_jle; break;
  case 3: opcode[in]=op_jeq; break;
  case 4: opcode[in]=op_jhe; break;
  case 5: opcode[in]=op_jgt; break;
  case 6: opcode[in]=op_jne; break;
  case 7: opcode[in]=op_jnc; break;
  case 8: opcode[in]=op_joc; break;
  case 9: opcode[in]=op_jno; break;
  case 10:opcode[in]=op_jl; break;
  case 11:opcode[in]=op_jh; break;
  case 12:opcode[in]=op_jop; break;
  case 13:opcode[in]=op_sbo; break;
  case 14:opcode[in]=op_sbz; break;
  case 15:opcode[in]=op_tb; break;
  default: opcode[in]=op_bad;
}}

void opcode2(Word in)
{ unsigned short x;

x=(in&0x0c00)>>8;

switch(x)
{ case 0: opcode[in]=op_coc; break;
  case 4: opcode[in]=op_czc; break;
  case 8: opcode[in]=op_xor; break;
  case 12:opcode[in]=op_xop; break;
  default: opcode[in]=op_bad;
}}

void opcode3(Word in)
{ unsigned short x;

x=(in&0x0c00)>>8;

switch(x)
{ case 0: opcode[in]=op_ldcr; break;
  case 4: opcode[in]=op_stcr; break;
  case 8: opcode[in]=op_mpy; break;
  case 12:opcode[in]=op_div; break;
  default: opcode[in]=op_bad;
}}


void do_files(int n) {			/* call files(n) */
  Byte *p;
  int adr = 0x4000 - n*518 - 534; /* first address of disk data (FIXME: ignore previously allocated space) */

  if (v9938)
	adr |= (VDPREG[14] & 0x07) << 14;
  wrword(0x8370, (adr-1) & 0x3fff);	/* last free byte in VDP RAM */
  p = &VDP[adr];
  *p++ = 0xaa;					/* ident */
  *p++ = 0x3f;					/* link (last entry) */
  *p++ = 0xff;
  *p++ = 0x11;					/* CRU page */
  *p++ = n;						/* max. number of files */
  for (; n; n--) {
	*(p+6) = 0;					/* clear first byte of FDS to indicate unused buffer */
	p += 518;					/* next buffer */
  }
}


void do_dsrlnk()
{
	// performs file i/o using the PAB passed as per a normal
	// dsrlnk call. *Only* does LOAD image reads from
	// DSK1, because I don't need more than that for SSA
	
	// address of length byte passed in CPU >8356

	int PAB;
	char *filename;

	PAB = romword(0x8356)-14;	// base address of PAB in VDP RAM
	if (v9938)
	  PAB |= (VDPREG[14] & 0x07) << 14;
	buildfilename(&filename, PAB);
	if (filename==NULL) {
	  setfileerror(PAB, 0xe0); // file error
	  return;
	}

	switch (VDP[PAB]) {
	case 0x01:		/* close */
	  // we'll support CLOSE (0x01) just because it happens in case of Errors
	  // but we won't do anything about it
	  fprintf(stderr, "closing %s\n", filename);
	  break;
	case 0x05:		/* load */
	  load(filename, PAB);
	  break;
	case 0x06:		/* save */
	  save(filename, PAB);		// SAVE, just to be nice
	  break;
	default:
		// bad opcode. Boy, this DSR sucks ;)
		// set return byte in PAB and exit
	  fprintf(stderr, "unsupported DSRLNK opcode %d on file %s\n",
		  VDP[PAB], filename);
	  setfileerror(PAB, 0x040);		// Bad open attribute
	  break;
	}

	free(filename);
}

void load(char *filename, int PAB) {
	int buffer, max_bytes;
	int idx, b;
	FILE *fp;
	Byte drive;

	drive=VDP[PAB+13] - '0';	// drive number
	buffer = ((VDP[PAB+2]<<8) | VDP[PAB+3])&0x3fff;	// VDP buffer
	if (v9938)
	  buffer |= (VDPREG[14] & 0x07) << 14;
	max_bytes=(VDP[PAB+6]<<8) | VDP[PAB+7];		// maximum bytes to read

	if (disktype[drive] == 'i') {
	  fprintf(stderr, "loading on image disk %d not yet supported\n", drive);
	  setfileerror(PAB, 0xe0);		// file error
	  return;
	}

#if 0
/**************** DISPLAY FILENAME ON SCREEN ********************/
// Done only if the screen table is at address 0
// Naturally, this is NOT correct TI behaviour
	SIT=(VDPREG[2]<<10)&0x3fff;
	if (SIT==0)
	{
		for (idx=0; idx<15; idx++)
			VDP[idx]=filename[idx];
	}
/****************************************************************/
#endif
	fp=fopen(filename, "rb");
	if (NULL == fp)
	{
	  fprintf(stderr, "cant load 0x%X bytes drive %d file %s\n",
			  max_bytes, drive, filename);
		// couldn't open the file
	  setfileerror(PAB, 0xe0);		// file error
	  return;
	}

	if (disktype[drive] == 'v' || disktype[drive] == 't') /* skip header */
	  fseek(fp, 128, SEEK_SET);

	max_bytes = fread(&VDP[buffer], 1, max_bytes, fp);
	fprintf(stderr, "loading 0x%X bytes drive %d file %s\n",
		max_bytes, drive, filename);

	setnofileerror(PAB);

	fclose(fp);					// all done
}

void save(char *filename, int PAB) {
	int buffer, max_bytes;
	int idx;
	FILE *fp;
	Byte drive;

	// Execute a SAVE opcode (Program image)
	
	drive=VDP[PAB+13] - '0';	// drive number
	buffer = ((VDP[PAB+2]<<8) | VDP[PAB+3])&0x3fff;	// VDP buffer
	if (v9938)
	  buffer |= (VDPREG[14] & 0x07) << 14;
	max_bytes=(VDP[PAB+6]<<8) | VDP[PAB+7];		// maximum bytes to read

	fprintf(stderr, "saving 0x%X bytes file %s\n",
		max_bytes, filename);

	if (disktype[drive] == 'i') {
	  fprintf(stderr, "saving on image disks not supported\n");
	  setfileerror(PAB, 0xe0);		// file error
	  return;
	}

	fp=fopen(filename, "wb");
	if (NULL == fp)
	{
		// couldn't open the file
	  fprintf(stderr, "cant open for writing\n");
	  setfileerror(PAB, 0xe0);		// file error
	  return;
	}

	if (disktype[drive] == 't') { /* create TIFILES header */
	  Byte h[128];				/* header */

	  memset(h, 0, 128);		/* initialize */
	  h[0] = 7;
	  h[1] = 'T';
	  h[2] = 'I';
	  h[3] = 'F';
	  h[4] = 'I';
	  h[5] = 'L';
	  h[6] = 'E';
	  h[7] = 'S';
	  h[8] = (max_bytes+255) >> 16;	/* length in sectors HB */
	  h[9] = (max_bytes+255) >> 8; /* LB */
	  h[10] = 0x01;				/* program */
	  h[11] = 0;				/* records/sector */
	  h[12] = max_bytes & 0xff;	/* # of bytes in last sector */
	  h[13] = 0;				/* record length */
	  h[14] = 0;				/* # of records(FIX)/sectors(VAR) LB! */
	  h[15] = 0;				/* HB */
	  fwrite(h, 1, 128, fp);
	}
	else if (disktype[drive] == 'v') { /* create v9t9 header */
	  Byte h[128];				/* header */
	  Byte *p;

	  memset(h, 0, 128);		/* initialize */
	  for (p=h; p < (h+VDP[PAB+9]); p++) {
		*p = VDP[PAB+15+(p-h)];
	  }
	  while (p<h+10)
		*p++ = ' ';				/* fill with blanks */
	  h[12] = 0x01;				/* program */
	  h[13] = 0;				/* records/sector */
	  h[14] = (max_bytes+255) >> 16; /* length in sectors HB */
	  h[15] = (max_bytes+255) >> 8; /* LB */
	  h[16] = max_bytes & 0xff;	/* # of bytes in last sector */
	  h[17] = 0;				/* record length */
	  h[18] = 0;				/* # of records(FIX)/sectors(VAR) LB! */
	  h[19] = 0;				/* HB */
	  fwrite(h, 1, 128, fp);
	}

/*  	for (idx = 0; idx < max_bytes; idx++) */
/*  	{ */
/*  		fputc(VDP[buffer+idx], fp); */
/*  	} */
	if (fwrite(VDP+buffer, 1, max_bytes, fp) == max_bytes)
	  setnofileerror(PAB);
	else
	  setfileerror(PAB, 0xe0);		// file error

	fclose(fp);					// all done
}

void setfileerror(int PAB, Byte errcode) {
  VDP[PAB+1] = errcode;		// file error
  CPU[0x837c] |= 0x20;		// are we supposed to set this bit?
}

void setnofileerror(int PAB) {
  VDP[PAB+1] = 0x00;		// no errors
  CPU[0x837c] &= 0xdf;		// clear COND bit
}

void buildfilename(char **filename, int PAB) {
  char *p;
  int idx;
  Byte len, drive;

  len=VDP[PAB+9] - 5;		// Filename length minus 'DSK1.' bit
  drive=VDP[PAB+13] - '0';	// drive number
  if (drive<1 || drive>9 || len<1 || diskpath[drive]==NULL) {
    *filename = NULL;
    return;
  }

  *filename = (char *) malloc(strlen(diskpath[drive]) + len + 1);
  p = (char *) stpcpy(*filename, diskpath[drive]); /* points to end */
  for (idx=0; idx<=len; idx++) { /* search end, convert name */
    if (idx==len || VDP[PAB+15+idx]==' ') {
      *p = 0;
      break;
    } else if (VDP[PAB+15+idx] == '/')
      *p++ = '_';
    else
      *p++ = tolower(VDP[PAB+15+idx]);
  }
  //  VDP[0x3eeb] = drive;			/* last accessed drive */
}

void do_sbrlnk() {
  // performs low level disk i/o using the PAB passed as per a normal
  // dsrlnk call.

  // address of length byte passed in CPU >8356

	int PAB;
	Byte drive;
	int sect;
	int opcode;

	opcode = (PC & 0xff)>>1;
	PAB = romword(0x8356);	// base address of PAB in VDP RAM
	if (v9938)
	  PAB |= (VDPREG[14] & 0x07) << 14;
	drive = CPU[0x834c];
	sect = romword(0x8350);

	if (drive<1 || drive>9 || diskpath[drive]==NULL) {
	  fprintf(stderr, "SBRLNK call to invalid drive %d\n", drive);
	  CPU[0x8350] = 0x06;	/* hardware error */
	}

	switch (opcode) {
	case 0x10: {				/* sector read/write */
	  int buffer = romword(0x834e)&0x3fff;	// VDP buffer
	  if (v9938)
		buffer |= (VDPREG[14] & 0x07) << 14;
	  fprintf(stderr, "%sing drive %d sector %d\n",
		  CPU[0x834d] ? "read" : "writ",
		  drive, sect);
	  if (CPU[0x834d]==0) {
	    CPU[0x8350] = 0x34;	/* write protected */
	  } else {
	    read_sect(drive, sect, &VDP[buffer]);
	  }
	  break;
	}
	case 0x16: {				/* call files */
	  Byte n = CPU[0x834c];
	  if (n>0 && n<=16) {
		do_files(n);
		CPU[0x8350] = 0;		/* no error */
	  } else	  
		CPU[0x8350] = 0xff;		/* error */
	  break;
	}
	default:
	  fprintf(stderr, "unsupported SBRLNK opcode 0x%x\n", opcode);
	  CPU[0x8350] = 0x06;	/* hardware error */
	  break;
	}
	//	VDP[0x3eeb] = drive;			/* last accessed drive */
}

int nodot(const struct dirent *d) {
  return (*(d->d_name) != '.');
}

void read_sect(Byte drive, int sect, char *buffer) {
  FILE *fp;
  
  switch (disktype[drive]) {
  case 'i':
	  fp = fopen(diskpath[drive], "rb");
	  if (fp) {
		fseek(fp, sect<<8, SEEK_SET);
		if (fread(buffer, 1, 256, fp)==256)
		  CPU[0x8350] = 0;	/* no error */
		else
		  CPU[0x8350] = 0x06;	/* hardware error */
		fclose(fp);
	  } else {
		fprintf(stderr, "cant open %s\n", diskpath[drive]);
		memset(buffer, 0, 256);
		CPU[0x8350] = 0x06;	/* hardware error */
	  }
	  break;
  case 'v':			/* v9t9: simulated directory sector access */
  case 't':			/* TIFILES: simulated directory sector access */
  case 'r':			/* raw: simulated directory sector access */
	  CPU[0x8350] = 0;		/* no error */
	  memset(buffer, 0, 256);	/* init buffer */
	  if (sect==0) {		/* sector 0 */
		char *p;
		if (strlen(diskpath[drive]) < 10) {
		  p = (char *) stpcpy(buffer, diskpath[drive]); /* points to end */
		  while (p < buffer+10)
			*p++ = ' ';
		} else {
		  strcpy(buffer, diskpath[drive] + strlen(diskpath[drive]) - 10);
		}
		p = buffer+0x0a;
		*p++ = 0x05;
		*p++ = 0xa0;
		*p++ = 0x12;
		*p++ = 'D';
		*p++ = 'S';
		*p++ = 'K';
		*p++ = 'P';
		*p++ = 0x28;
		*p++ = 0x02;
		*p++ = 0x02;
		for (p=buffer+0x38; p<buffer+256; p++)
		  *p = 0xff;
	  } else {			/* other sector */
		struct dirent **eps;
		int n;
      
		n = scandir(diskpath[drive], &eps, nodot, alphasort);
		if (sect==1) {
		  int i;
		  for (i=0; i<n && i<127; i++)
			buffer[2*i+1] = i+2;
		}
		else if (n>0 && sect>=2 && sect<n+2) {
		  char *p, *q;
		  int len;
		  char tifbuf[128];
		
		  p = (char *) malloc(strlen(diskpath[drive]) +
							  strlen(eps[sect-2]->d_name) + 1);
		  strcpy(p, diskpath[drive]);
		  strcat(p, eps[sect-2]->d_name);
		  fp=fopen(p, "rb");
		  switch (disktype[drive]) {
		  case 'v': 		/* v9t9: simulated directory sector access */
			  fread(buffer, 1, 0x1b, fp); /* file information without link map */
/*  			  fprintf(stderr, "v9t9 FDS %s\n", p); */
			  break;
		  case 'r': 		/* raw: simulated directory sector access */
			  fprintf(stderr, "raw FDS %s\n", p);
			  q = (char *) stpncpy(buffer, eps[sect-2]->d_name, 10);
			  while (q < buffer+10)
				*q++ = ' ';
			  fseek(fp, 0, SEEK_END);
			  len = ftell(fp);
			  buffer[0x0c] = 0x09;	/* always PROGRAM */
			  buffer[0x0e] = (len+255) >> 16;
			  buffer[0x0f] = (len+255) >> 8;
			  buffer[0x10] = len & 0xff;
			  break;
		  case 't': 		/* raw: simulated directory sector access */
/*  			  fprintf(stderr, "TIFILES FDS %s\n", p); */
			  q = (char *) stpncpy(buffer, eps[sect-2]->d_name, 10);
			  while (q < buffer+10)
				*q++ = ' ';
			  fread(tifbuf, 1, 128, fp); /* TIFILES header */
			  q += 2;					/* start at offset 0x0c */
			  *q++ = tifbuf[10];
			  *q++ = tifbuf[11];
			  *q++ = tifbuf[8];
			  *q++ = tifbuf[9];
			  *q++ = tifbuf[12];
			  *q++ = tifbuf[13];
			  *q++ = tifbuf[14];
			  *q = tifbuf[15];
			  break;
		  } /* switch */
		  fclose(fp);
		  free(p);
		} else {
		  fprintf(stderr, "attempt to read not simulated sector\n");
		  CPU[0x8350] = 0x06;	/* hardware error */
		}
		free(eps);
	  }
	  break;
  default:
	  fprintf(stderr, "sector access only implemented for images and v9t9\n");
	  CPU[0x8350] = 0x06;		/* hardware error */
  } /* switch */
}

#if 0
void read_image_file(int PAB, char *buffer, int offset, int len) {
  Byte bufs1[256], buffds[256], fn[10];
  Byte drive;
  Byte *p1, *p2, *p3;
  Word Start, Length;
  int found, fds, i;

  drive=VDP[PAB+13] - '0';	// drive number
  read_sect(drive, 1, bufs1);
  p1 = stpncpy(fn, VDP+PAB+15, VDP[PAB+9]-5);
  while (p1<fn+10)				/* fill with spaces for comparing */
	*p1++ = ' ';
  p1=bufs1, p2=bufs1+256;
  found=0;
  do {
	p = p1 + (((p2-p1)/2) & ~1);
	fds = (*p)<<8 | *(p+1);
	if (!fds) {
	  p2 = p;
	  continue;
	}
	read_sect(drive, fds, buffds);
	if (0 == (cmp=strncmp(fn, buffds, 10))) {
	  found=1;
	  break;
	} else if (cmp>0)
	  p1=p+2;
	else
	  p2=p;
  } while (p1<p2);
  if (found) {
	size = 256;
	Length = 0;
	Prog = buffds[12] & 1;
	Dis = (buffds[12] & 2) ? 0 : 1;
	Var = buffds[12] >> 7;
	Len = buffds[0x11];
	fprintf(stderr, "Copying %d %s %s %s%s%s%d\n\n", o, argv[o], filename,
	       Prog ? "P": " ",
	       !Prog && Dis ? "D": " ",
	       !Prog && Var ? "V": " ",
			Len);
	for (p3 = buffds+0x1c;
	     *p3 | *(p3+1);
	     p3 += 3) {		/* all chunks */
	  Start = *p3 | ((*(p3+1) & 0x0f) << 8);
	  Length = (((*(p3+1) & 0xf0) >> 4) | (*(p3+2) << 4)) - Length;
	  for (i=0; i<=Length; i++) { /* read every sector */
	    read_sect(Start++, buffer);
		if (Prog && i==Length && (*(p3+3) | *(p3+4)) == 0)
		  size =  buffds[0x10] ?  buffds[0x10] : 256;
		/* last sector of P-File: shorter */
		fwrite(buffer, size, 1, outfile);
	  } /* for i */
	} /* for p3 */
  } /* found / for p */
}
#endif


// Local Variables: //
// tab-width:4 //
// comment-column:32 //
// fill-column:100 //
// End: //
