#ifdef WIN32
/////////////////////////////////////////////////////////////////////////
// Window handler
/////////////////////////////////////////////////////////////////////////
LONG FAR PASCAL myproc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	// this process must also handle WM_KEYDOWN, WM_KEYUP, and WM_COMMAND (for alt-enter)
	// WM_SYSKEYDOWN can be used to make changes to modes (returns for ALT+key)
	// winuser.h has the VK_key key defines
	// also fill in the key[] array for on/off
    
	PAINTSTRUCT ps;
    HDC 	hDC;
	char szTemp[1024];
	float height;
	int i1;
	RECT myrect, myrect2;
	float scale;

    switch(msg) {

	case WM_PAINT:
		hDC = BeginPaint(hwnd, &ps);
		SetEvent(BlitEvent);
		EndPaint(hwnd, &ps);
        break;

	case WM_DESTROY:
		quitflag=1;
		PostQuitMessage(0);
        break;
	
	case WM_KEYDOWN:
		key[wParam]=1;
		break;

	case WM_KEYUP:
		key[wParam]=0;
		break;

	case WM_SYSCHAR:
		// ignore these, we don't use them. Without this, FCTN keys all Ding because they don't
		// map to a shortcut in the menu bar ;)
		break;

	case WM_SYSKEYDOWN:				// returns from ALT and ALT+KEY (I use as FCTN)
		// some system keys we want Windows to process, namely F4 (close), and Enter (size)
		if ((wParam != VK_F4) & (wParam != VK_RETURN))
		{	
			key[wParam]=1;
		}
		else
		{
			switch (wParam)
			{
			case VK_F4:
				quitflag=1;
				PostQuitMessage(0);
				break;
			
			case VK_RETURN:
				// TODO - full screen and back
			default:
				return(DefWindowProc(hwnd, msg, wParam, lParam));
			}
		}
		break;

	case WM_SYSKEYUP:
		key[wParam]=0;
		break;

	case WM_COMMAND:
		switch (wParam)
		{
		case ID_HELP_ABOUT:
			sprintf(szTemp, "Ami99 %s\nCreated by Mike Brent (Tursi)\n(c)1994-1999\n\nThanks to Jeff Brown, Frank Palazolo\nand Ralph Nebet for assistance.\nThanks to Darrin and Stiletto\nfor encouragement.\nProgrammed by Mike Brent (Tursi)\n\nContains additional code by:\nFrank Palazolo - Speech (MAME)\nRalph Nebet - Speech Fixes (MESS)\nJohn Butler - 9900 Disasm (MAME)\n\ntursi@orcas.net", VERSION);
			MessageBox(myWnd, szTemp, "Ami99 About", MB_OK);
			return 0;
			break;

		case ID_FILE_RESET:
			ST=(ST&0xfff0);							// disable interrupts
			WP=romword(0x0000);						// Reset = BLWP @>0000
			wrword(WP+26,0xffff);
			wrword(WP+28,PC);
			wrword(WP+30,ST);
			PC=romword(0x0002);
			grmaccess=0;		// No GROM Access yet
			vdpaccess=0;		// No VDP address writes yet 
			interrupt_needed=0;	// No interrupt missed yet
			break;

		case ID_FILE_QUIT:
			quitflag=1;
			PostQuitMessage(0);
			break;
		
		case ID_VIDEO_50HZ:
			if (hzRate == 60)
			{
				hzRate=50;
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_50HZ, MF_CHECKED);
			}
			else
			{
				hzRate=60;
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_50HZ, MF_UNCHECKED);
			}
			ResetTimer();
			break;

		case ID_VIDEO_STARTRECORDING:
			if (Recording == 0)
			{
				debug_write("Starting AVI recording");
				if (0==InitAvi())
				{
					SetWindowText(myWnd, "Ami99 - Recording AVI");
					Recording=1;
					RecordFrame=0;
				}
			}
			break;
		
		case ID_VIDEO_STOPRECORDING:
			if (Recording)
			{
				debug_write("Stoping AVI recording");
				SetWindowText(myWnd, "Ami99");
				CloseAVI();
				Recording=0;
			}
			break;

		case ID_VIDEO_MAINTAINASPECT:
			if (MaintainAspect)
			{
				MaintainAspect=0;
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_MAINTAINASPECT, MF_UNCHECKED);
			}
			else
			{
				MaintainAspect=1;
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_MAINTAINASPECT, MF_CHECKED);
			}
			break;

		case ID_OPTIONS_DRAWINACTIVE:
			if (DrawInactive)
			{
				DrawInactive=0;
				CheckMenuItem(GetMenu(myWnd), ID_OPTIONS_DRAWINACTIVE, MF_UNCHECKED);
			}
			else
			{
				DrawInactive=1;
				CheckMenuItem(GetMenu(myWnd), ID_OPTIONS_DRAWINACTIVE, MF_CHECKED);
			}
			break;

		case ID_OPTIONS_PAUSEINACTIVE:
			if (PauseInactive)
			{
				PauseInactive=0;
				CheckMenuItem(GetMenu(myWnd), ID_OPTIONS_PAUSEINACTIVE, MF_UNCHECKED);
			}
			else
			{
				PauseInactive=1;
				CheckMenuItem(GetMenu(myWnd), ID_OPTIONS_PAUSEINACTIVE, MF_CHECKED);
			}
			break;


		default:
	        return(DefWindowProc(hwnd, msg, wParam, lParam));

		}

	case WM_SIZE:
			if (MaintainAspect)
			{
				GetWindowRect(myWnd, &myrect);
				GetClientRect(myWnd, &myrect2);
				i1=((myrect.right - myrect.left)-(myrect2.right - myrect2.left))/2;
				myrect.left += i1;
				myrect.right = myrect.left + myrect2.right;
				myrect.bottom -= i1;
				myrect.top = myrect.bottom - myrect2.bottom;
				
				height=(float)((myrect.right - myrect.left) * 0.75);
				height-=(myrect.bottom - myrect.top);

				if (height)
				{
					GetWindowRect(myWnd, &myrect);
					myrect.bottom+=(long)height;
					MoveWindow(myWnd, myrect.left, myrect.top, myrect.right-myrect.left, myrect.bottom-myrect.top, true);
				}
			}
			break;

	case WM_MOUSEACTIVATE:
			SetEvent(BlitEvent);
			return(DefWindowProc(hwnd, msg, wParam, lParam));
			break;

	case WM_MOUSEMOVE:
			GetClientRect(myWnd, &myrect);
			MouseX = lParam&0xffff;					// horizontal position of cursor 
			MouseY = lParam>>16;					// vertical position of cursor 
			// now scale it down
			scale = (float)(myrect.right-myrect.left)/(float)wti;
			MouseX = (int)((float)MouseX/scale);
			scale = (float)(myrect.bottom-myrect.top)/(float)hti;
			MouseY = (int)((float)MouseY/scale);
			return 0;
			break;

	case WM_LBUTTONDOWN:
			MouseB |= 0x01;
			return 0;
			break;

	case WM_LBUTTONUP:
			MouseB &= 0x02;
			return 0;
			break;

	case WM_RBUTTONDOWN:
			MouseB |= 0x02;
			return 0;
			break;

	case WM_RBUTTONUP:
			MouseB &= 0x01;
			return 0;
			break;

	default:
        return(DefWindowProc(hwnd, msg, wParam, lParam));
    }

    return(0);
}

#endif