/* Konversion von Textfiles (DV80) im TIFILES-Format
   (automatisch erzeugt beim Upload von einem TI-Terminalprogramm)
   nach (Unix-) Text
   07.10.94 Roland Meier
*/

#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
  char b[384];
  FILE *fin,*fout;
  char *p,*p0;
  unsigned int i;

  if ((argc>3)|| (argc<2)) {
    fprintf(stderr,"usage: %s TIFILES-File [txtfile]\n", argv[0]);
    exit(1);
  }
  if (!strcmp(argv[1],"-"))
    fin=stdin;
  else if ((fin=fopen(argv[1],"r"))==NULL) {
    fprintf(stderr,"%s: can't open input-file %s\n", argv[0], argv[1]);
    exit(2);
  }
  fread(b,1,128,fin);
  if (strncmp(b+1,"TIFILES",7)) {
    fprintf(stderr,"%s: no TIFILES header in %s\n", argv[0], argv[1]);
    exit(3);
  }
  if ((argc==2) || (fout=fopen(argv[2],"w"))==NULL)
    fout=stdout;
  while (fread(b,1,256,fin)) {
    if (!strncmp(b+1,"TIFILES",7)) { /* Konkatenation mehrerer Files */
      fread(b+256,1,128,fin);
      p=b+128;
    }
    else
      p=b;
    p0=p;
    while ((i= (unsigned int) *p++) < 255) {
      if ((p+i) > (p0+255)) {	/* kein Endeflag */
	fprintf(stderr,"%s: %s is no regular textfile\n", argv[0], argv[1]);
	exit(4);
      }
      fwrite(p,1,i,fout);
      fputc('\n',fout);
      p += i;
    }
  }
  fclose(fout);
  fclose(fin);
  return(0);
}
